#include <stdio.h>
#include <sys/file.h>

#define readFileTillChar(tc) \
	while (c = getchar()) if (c == EOF || c == tc) break;

#define BUFF_SIZE 100000 /*XXX*/

char c;
char buff[BUFF_SIZE];

parse()
{
	char label[100];
	int labeli, sloti;
	long seekBackPosition = 0;
	int doneObj = 0;
	int doneFile = 0;
	int llc = 0, lc = 0, c, nc;

	for (;;) {

		/* read the slot label */
		labeli = 0;
		llc = 0; lc = 0;
		for (;;) {
			c = getchar();

			if (c == EOF) {
				doneFile = 1;
				goto donecontent;
			} else if (c == '\\') {
				if (lc == '\\') {
					/* \\comments */
					readFileTillChar('\n');
					labeli = 0;
					llc = 0; lc = 0;
				} else if (lc == '\n') {
					doneObj = 1;
					goto donecontent;
				}
			} else if (c == '{') {
				break;
			} else if (!isspace(c)) {
				label[labeli++] = c;
			}
			label[labeli] = '\0';
			llc = lc; lc = c;
		}
		label[labeli++] = '\0';

		printf("\"%s\",\n\"", label);

		/* read the slot content */
		sloti = 0;
		llc = 0; lc = 0;
		for (;;) {
			c = getchar();
			if (c == EOF) {
				if (lc == '\n') {
					doneFile = 1;
					goto donecontent;
				} else if (lc == '}') {
					doneFile = 1;
					goto donecontent;
				} else {
					fprintf(stderr, "premature EOF...\n");
					doneFile = 1;
					goto donecontent;
				}
			} else if (c == '\\') {
				if (llc == '}' && lc == '\n') {
					goto donecontent;
				}
			}
			if (llc) {
				if (llc == '\\')
					printf("\\\\");
				else if (llc == '\n')
					printf("\\n\\\n");
				else if (llc == '\"')
					printf("\\\"");
				else
					printf("%c", llc);
			}

			llc = lc; lc = c;
		}
donecontent:
		if (doneObj) {
			printf("(char*)0,(char*)1, /* END OF OBJ */\n\n");
			doneObj = 0;
		} else if (doneFile) {
			printf("(char*)0,(char*)0, /* END OF FILE */\n\n");
			return;
		} else {
			printf("\",\n\n");
		}
	}
}

main(argc, argv)
	int argc;
	char **argv;
{
	printf("static char* objDesc_%s[] = {\n", argv[1]);
	parse();
	printf("};\n\n");
	exit(0);
}

