\name {ed_script}
\class {vpane}
\parent {}
\lock {1}
\width {500}
\height {200}
\script {
	switch (arg[0]) {
	case "edit":
		cloneID = cloneID + 1;
		new = clone(cloneID); 	/* ``fork off'' a clone editor */
		send(new, "editData", arg[1]);
		return;
	break;
	case "editData":
		render();
		objectListSend("children", "edit", arg[1]);
		return;
	break;
	case "apply":
		send(nthChild(1), arg[0]);
		render();
		return;
	break;
	case "cancel":
		set("visible", 0);  /* this crashses Xserver!*/
/*		destroy();*/
		return;
	break;
	}
	usual();
}
\children {ed_script.top ed_script.work}
\
\name {ed_script.top}
\class {hpane}
\parent {ed_script}
\children {ed_script.top.title ed_script.top.apply ed_script.top.cancel}
\lock {1}
\script {
	switch (arg[0]) {
	case "apply":
	case "cancel":
		send(get("parent"), arg[0]);
		return;
	break;
	case "edit":
		send(nthChild(0), "title", arg[1]);
		return;
	break;
	}
	usual();
}
\maxHeight {20}
\
\name {ed_script.top.title}
\class {txtLabel}
\parent {ed_script.top}
\lock {1}
\script {
	switch (arg[0]) {
	case "title":
		set("label", arg[1]);
		return;
	break;
	}
	usual();
}
\font {normal}
\BDColor {white}
\BGColor {grey45}
\FGColor {white}
\
\name {ed_script.top.apply}
\class {txtButton}
\parent {ed_script.top}
\label {Apply}
\lock {1}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send(get("parent"), "apply");
	break;
	}
	usual();
}
\font {normal}
\BDColor {white}
\BGColor {grey45}
\FGColor {white}
\maxWidth {70}
\
\name {ed_script.top.cancel}
\class {txtButton}
\parent {ed_script.top}
\lock {1}
\label {Cancel}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send(get("parent"), "cancel");
	break;
	}
	usual();
}
\font {normal}
\BDColor {white}
\BGColor {grey45}
\FGColor {100 75 75}
\maxWidth {70}
\
\name {ed_script.work}
\class {hpane}
\parent {ed_script}
\lock {1}
\script {
	switch (arg[0]) {
	case "apply":
		send(nthChild(1), arg[0]);
		return;
	break;
	case "edit":
		send(nthChild(1), "edit", arg[1]);
		render();
		return;
	break;
	}
	usual();
}
\lock {1}
\children {ed_script.work.sb ed_script.work.tf}
\
\name {ed_script.work.sb}
\class {slider}
\parent {ed_script.work}
\lock {1}
\BDColor {grey99}
\BGColor {grey45}
\FGColor {grey70}
\shownNotify {ed_script.work.tf}
\maxWidth {15}
\
\name {ed_script.work.tf}
\parent {ed_script.work}
\lock {1}
\class {txtEdit}
\script {
	switch (arg[0]) {
	case "apply":
		setSelection(get("content"));
/*		print("*** 1apply: data=", get("content"), "\n");*/
/*		print("*** 2apply: data=", getSelection(), "\n");*/
		tweak(dataSource, "set(\"script\", getSelection());");
		send(dataSource, "render");
		return;
	break;
	case "edit":
		dataSource = arg[1];
		cc = tweak(arg[1], "get(\"script\");");
/*		print("*** obj=", arg[1], "\n");
		print("*** data=", cc, "\n");
*/
		set("content", tweak(dataSource, "get(\"script\");"));
		render();
		return;
	break;
	}
	usual();
}
\shownDepend {ed_script.work.sb}
\font {normal}
\BGColor {grey45}
\FGColor {white}
\BDColor {black}
\CRColor {yellow}
\verbatim {1}
\














