\name {HMML_input_slider}
\parent {}
\class {hpane}
\security {1}
\children {HMML_input_slider.v HMML_input_slider.s}
\script	{
	switch (arg[0]) {
	case 'R':
		/* arg[1]	y
		 * arg[2]	width
		 */
		set("y", arg[1]);
		set("width", arg[2]);
		return get("height") + 2;
	break;
	case "make":
		/* arg[1]	parent
		 * arg[2]	defaultValue
		 * arg[3]	width
		 * arg[4]	height
		 */
		tagPtr = STG_tagPtr("INPUT");
		if (tagPtr) {
			i = STG_attr(tagPtr, "BGColor");
			if (i) set("BGColor", i);
			i = STG_attr(tagPtr, "FGColor");
			if (i) set("FGColor", i);
			i = STG_attr(tagPtr, "BDColor");
			if (i) set("BDColor", i);
		}

		set("parent", arg[1]);
		set("content", arg[2]);
		set("width", arg[3]);
		set("height", arg[4]);
		return get("height");
	break;
	case "setVal.v":
		val = arg[1];
		send(nthChild(1), "setVal", val);
		return;
	break;
	case "setVal.s":
		val = arg[1];
		send(nthChild(0), "setVal", val);
		return;
	break;
	case "clone":
		return clone(arg[1]);
	break;
	}
	usual();
}
\BDColor {black}
\width {100}
\height {19}
\
\parent {HMML_input_slider}
\name {HMML_input_slider.v}
\class {txtEdit}
\security {1}
\shownDepend {HMML_input_slider.s}
\script	{
	print("@@@@@@ HTML_input_slider.v clsss = txtEdit. args: ");
	for (i =0; i < arg[]; i++) print(arg[i], ", ");
	print("\n");

	switch (arg[0]) {
	case "setVal":
	case "shownPositionH":
		set("content", arg[1]);
		render();
		return;
	break;
	case "keyPress":
		if (key() == '\r') {
			v = get("content");
			if (v > 100) {
				v = 100;
				set("content", 100);
				render();
			}
			send(parent(), "setVal.v", v);
			interpret(concat("__formVal__", val, " = \"",
					v, "\";"));
			print("###### verify: __formVal__ = {", val, "}\n");
			return;
		}
	break;
	}
	usual();
}
\BDColor {black}
\BGColor {grey45}
\FGColor {white}
\maxWidth {30}
\
\class {slider}
\security {1}
\parent {HMML_input_slider}
\name {HMML_input_slider.s}
\shownNotify {HMML_input_slider.v}
\script	{
	print("@@@@@@ HTML_input_slider.s clsss = slider: args: ");
	for (i =0; i < arg[]; i++) print(arg[i], ", ");
	print("\n");

	switch (arg[0]) {
	case "make":
		/* arg[1]	defaultValue
		 */
		set("shownPositionH", arg[1]);
		return;
	break;
	case "setVal":
		set("shownPositionH", arg[1]);
		render();
		return;
	break;
	case "getVal":
		return get("shownInfoH");
	break;
	case "clone":
		return clone(arg[1]);
	break;
	}
	usual();
}
\direction {left2right}
\BDColor {black}
\BGColor {grey45}
\FGColor {white}
\
