\class {txtDisp}
\security {1}
\name {HMML_txt}
\script {
	switch (arg[0]) {
	case 'D': /* done */
		tagPtr = STG_tagPtr("P");
		if (tagPtr) {
			i = STG_attr(tagPtr, "BGColor");
			if (i) set("BGColor", i);
			i = STG_attr(tagPtr, "FGColor");
			if (i) set("FGColor", i);
			i = STG_attr(tagPtr, "BDColor");
			if (i) set("BDColor", i);
			i = STG_attr(tagPtr, "fontSlant");
			if (i) {
				switch (i) {
				case "italic": 	set("font", i);	break;
				case "bold": 	set("font", i);	break;
				default:
				case "normal":	set("font", i);	break;
				}
			}
		}
		set("content", get("label"));
		set("label", "");
		isHTML = 1;
		return building_vspan();
	break;
	case 'R': /* resize */
		clearWindow();
		if (style == 0) style = SGMLGetStyle("HMML", "P");
		vspan = style[0];
		set("y", arg[1] + vspan);
		set("x", style[2]);
		set("width", arg[2] - x() - style[3]);
		set("content", get("content"));
		vspan = vspan + set("height", building_vspan()) + style[1];
		render();
		return vspan;
	break;
	case 'r':
		if (style == 0) style = SGMLGetStyle("HMML", "P");
		vspan = style[0];
		set("width", width() - style[3]);
		set("content", get("content"));
		clearWindow();
		render();/*may be extraneous */
		vspan = vspan + set("height", building_vspan()) + style[1];
		return vspan;
	break;
	case "AI":
		return;
	break;
	case "AA":
		switch (arg[1]) {
		case "ID":
			id = arg[2];	/* NOT USED YET */
		break;
		case "STYLE":
			switch (arg[2]) {
			case "QUOTE":
				set("BGColor", "");
			break;
			case "MARGIN":
			break;
			case "NOTE":
				set("BDColor", "tan");
			break;
			case "CAUTION":
				set("BDColor", "orange");
			break;
			case "WARNING":
				set("BDColor", "red1");
			break;
			case "ERROR":
				set("FGColor", "white");
				set("BGColor", "red1");
			break;
			case "NORMAL":
			default:
			break;
			}
		break;
		case "COMPACT":
			compact = 1; 	/* NOT USED YET */
		break;
		case "MAXWIDTH":
			set("maxWidth", arg[2]);
		break;
		case "MINWIDTH":
			set("minWidth", arg[2]);
		break;
		}
		return;
	break;
	case "setAnchor":
		name = arg[1];
		return;
	break;
	case "gotoAnchor":
		if (name == arg[1]) return y();
		return 0;
	break;
	case "heightP":
		return get("height");
	break;
	case "widthP":
		return get("width");
	break;
	case "config":
		clearWindow();
		usual();		
		return;
	break;
	case "buttonRelease":
		return code_HTML_txt(arg);
	break;
	}
	usual();
}
\width {100}
\height {30}
\font {normal}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\FGColor {black}
\format {1}
\
