\class {vpane}
\name {www}
\parent {}
\children {www.top www.doc www.mesg www.url}
\script {
/*
print("www: ");
for (i=0; i < arg[]; i++) print("arg", i, " = ", arg[i], "\n");
print("\n");
*/
	/* Application: ViolaWWW
	 * Author: 	Pei Y. Wei
	 *
	 */
	/* URL port configurtion.
	 * 
	URLPort = 8081;
	URLListen = "/usr/work/viola/src/viola/listen";
	 */

	/*
	 *
	 */
	switch (arg[0]) {
	case "show":
	case "post":
		cursorShape("busy");
		if (arg[] == 2) {
			stat = send("www.doc.view.pane", arg[0], arg[1]);
		} else if (arg[] == 3) {
			stat = send("www.doc.view.pane", arg[0], arg[1], 
							 arg[2]);
		} else {
			stat = send("www.doc.view.pane", arg[0], arg[1], 
							 arg[2], arg[3]);
		}
		if (stat) stat = send("www.doc.view.pane", "historyRecord");

		cursorShape("idle");
		return stat;
	break;
	case "showHistoryDoc":
		cursorShape("busy");
		if (arg[] == 2) {
			stat = send("www.doc.view.pane", "show", arg[1]);
		} else {
			stat = send("www.doc.view.pane", "show", arg[1], 
					arg[2]);
		}
		cursorShape("idle");
		return stat;
	break;
	case "addToHistory":
		send("wwwHistory", "add", arg[1], arg[2]);
		return;
	break;
	case "group":
		send("www.doc.title.icon", "group", arg[1]);
		return;
	break;
	case "destroyDoc":
		return send("www.doc.view.pane", "destroyDoc");
	break;
	case "search":
		return send("www.doc.view.pane", "search", arg[1]);
	break;
	case "olAdd":
/*		olObj[olIdx] = arg[1];*/
		olData[olIdx] = arg[2];
		olIdx = olIdx + 1;
		return;
	break;
	case "olReset":
		olIdx = 0;
		return;
	break;
	case "olData":
		tt = "";
		for (i = 0; i < olIdx; i++) 
			tt = concat(tt, olData[i], "\n");
		return tt;
	break;
	case "showButNoRecord":
		www.doc.view.pane("show", arg[1]);
		return;
	break;
	case "about":
		cursorShape("busy");
		send("www.doc.view.pane", "show", 
				concat(environVar("VIOLA"), 
					"/violaDocs/docs/viola/about.html"),
				"file:");
		cursorShape("idle");
		send("www.doc.view.pane", "historyRecord");
		return;
	break;
	case "help":
		cursorShape("busy");
		send("www.doc.view.pane", "show", 
				concat(environVar("VIOLA"), 
					"/violaDocs/docs/viola/help.html"),
				"file:");
		cursorShape("idle");
		send("www.doc.view.pane", "historyRecord");
		return;
	break;
	case "home":
		send("www.doc.view.pane", "show", homeDoc);
		send("www.doc.view.pane", "historyRecord");
		return;
	break;
	case "prev":
		wantIt = wwwHistory("prev");
		if (isBlank(wantIt)) {
			send("www.mesg.tf", "alert", 
				"No ``previous'' document to go to.");
		} else {
			send("www.doc.view.pane", "show", wantIt);
		}
		return;
	break;
	case "next":
		wantIt = send("wwwHistory", "next");
		if (isBlank(wantIt)) {
			send("www.mesg.tf", "alert", 
				"No ``next'' document to go to.");
		} else {
			send("www.doc.view.pane", "show", wantIt);
		}
		return;
	break;
	case "back":
		wantIt = send("wwwHistory", "back");
		if (isBlank(wantIt)) {
			send("www.mesg.tf", "alert", 
				    "No Previous document to go back to.");
		} else {
			send("www.doc.view.pane", "show", wantIt);
		}
		return;
	break;
	case "reload":
		send("www.doc.view.pane", arg[0]);
		return;
	break;
	case "tear":
		send(nthChild(1), "tear");
		return;
	break;
	case "authorContact":
		send("www.doc.view.pane", "mailToAuthor");
		return;
	break;
	case "raise":
		raise();
		if (get("window")) windowName("violaWWW");
		return;
	break;
	case "busy":
		cursorShape("busy");
		return;
	break;
	case "idle":
		cursorShape("idle");
		return;
	break;
	case "quit":
		quit();
/*
		res("decAppCount");
		demo("visible", 0);
*/
		return;
	break;
	case "searchByTag":
		send("www.doc.view.pane", "searchByTag", arg[1], arg[2]);
		return;
	break;
	case "homeDocP":
		return homeDoc;
	break;
	case "changeFonts":
		send("res.font", arg[1]);
		/* bug: only main viewer is told of the font change */
		send("www.doc.view.pane", "configSelf");
		return;
	break;
	case "visible":
		if (arg[1] == 1) res("incAppCount");
	break;
	case "init":
		usual();

		res("incAppCount");

		homeDoc = environVar("WWW_HOME");
		if (isBlank(homeDoc) == 1) {
			homeDoc = accessible("file:/usr/local/lib/WWW/default.html");
			if (isBlank(homeDoc) == 1)
			    homeDoc = "http://info.cern.ch/hypertext/WWW/TheProject.html";
		}
		if (nthChar(homeDoc, 0) == '/')
			homeDoc = concat("file:", homeDoc);

		after(1, "www", "show", homeDoc);

		if (URLPort > 0) {
			print("WARNING: port number ", URLPort,
			" is now being used to accept URL fetch directives.");
			if (send("wwwDocuPort", "listen", URLPort, URLListen)){
				print("ERROR: Sorry, failed to open port ",
				URLPort, " for listening to URL fetches\n");
			}
		}
		return;
	break;
	case "outputSGML":
		send("www.doc.view.pane", "outputSGML");
		return;
	break;
	case "version":
		return "Version 2.0 (93/01/27)";
	break;
	}
	usual();
}
\x {550}
\y {10}
\width {595}
\height {700}
\BGColor {55 55 55}
\
\class {hpane}
\name {www.top}
\parent {www}
\children {www.top.files www.top.options www.top.links_public www.top.links_local www.top.links_private www.top.mark www.top.gap}
\maxHeight {23}
\BDColor {black}
\BGColor {grey45}
\FGColor {white}
\gapH {1}
\gapV {3}
\
\class {txtButton}
\name {www.top.mark}
\parent {www.top}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		pageObj = www.doc.view("whichPageP");
		title = send(pageObj, "queryTitle");
		address = send(pageObj, "queryAddress");
		www.top.links_private("add", title, address);
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click it to mark the current document.";
	break;
	}
	usual();
}
\label {<<}
\maxWidth {20}
\BDColor {white}
\BGColor {grey45}
\FGColor {white}
\
\class {menu}
\name {www.top.links_private}
\parent {www.top}
\script {
	switch (arg[0]) {
	case "add":
		set("menuConfig", concat(get("menuConfig"), "\n", 
			".{", arg[1], "} {www(\"show\", \"", arg[2], "\");}"));
		return;
	break;
	case "save":
		prompt("show", 
			concat("Saving private bookmarks to: ", path, "."));
		status = saveFile(path, get("menuConfig"));
		if (status == -1) 
			prompt("show", 
				concat("Warning: failed to save private bookmarks to: ", path, "."));
		return;
	break;
	case "clear_file":
		dialog("will clear file too, sure?", 
			self(), "clear_file_really");
		return;
	break;
	case "clear_file_really":
		saveFile(path, "");
	break;
	case "clear":
		set("menuConfig", "");
		return;
	break;
	case "edit":
		prompt("show", "firing up editor to edit private bookmarks");
		system(concat("xterm -e emacs -nw ", path, "&"));
		return;
	break;
	case "init":
		/* Expect book mark in following sequence:
		 */
		path = environVar("WWWBookMarks");
		if (path == "") path = accessible(".WWWBookMarks");
		if (path == "") path = accessible("~/.WWWBookMarks");
		if (path == "") path = accessible("~/WWWBookMarks");
		if (path == "") path = accessible("~/WWW/BookMarks");

		if (path != "") {
			set("menuConfig", loadFile(path));
		} else {
			set("menuConfig", get("content"));
		}
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Personal private book marks (not saved).";
	break;
	}
	usual();
}
\content {.{}}
\label {Private}
\BDColor {white}
\BGColor {grey45}
\FGColor {white}
\CRColor {grey75}
\font {normal}
\
\class {menu}
\name {www.top.links_local}
\parent {www.top}
\script {
	switch (arg[0]) {
	case "add":
		set("menuConfig", concatenate(get("menuConfig"), "\n", 
			".{", arg[1], "} {www(\"show\", \"", arg[2], "\");}"));
		return;
	break;
	case "init":
		/* Expect book mark in following sequence:
		 */
		path = environVar("WWWBookMarks_local");
		if (path == "") path = accessible(".WWWBookMarks_local");
		if (path == "") path = accessible("~/.WWWBookMarks_local");
		if (path == "") path = accessible("~/WWWBookMarks_local");
		if (path == "") path = accessible("~/WWW/BookMarks_local");

		if (path != "") {
			set("menuConfig", loadFile(path));
		} else {
			set("menuConfig", get("content"));
		}
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Personal private book marks (not saved).";
	break;
	}
	usual();
}
\content {.{/usr/local/lib/WWW/default.html} {www("show", "/usr/local/lib/WWW/default.html");}
}
\label {Local}
\BDColor {white}
\BGColor {grey45}
\FGColor {white}
\CRColor {grey75}
\font {normal}
\gapH {1}
\
\class {menu}
\name {www.top.links_public}
\parent {www.top}
\script {
	switch (arg[0]) {
	case "add":
		set("menuConfig", concatenate(get("menuConfig"), "\n", 
			".{", arg[1], "} {www(\"show\", \"", arg[2], "\");}"));
		return;
	break;
	case "init":
		/* Expect book mark in following sequence:
		 */
		path = environVar("WWWBookMarks_public");
		if (path == "") path = accessible(".WWWBookMarks_public");
		if (path == "") path = accessible("~/.WWWBookMarks_public");
		if (path == "") path = accessible("~/WWWBookMarks_public");
		if (path == "") path = accessible("~/WWW/BookMarks_public");
		if (path != "") {
			set("menuConfig", loadFile(path));
		} else {
			set("menuConfig", get("content"));
		}
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Private book marks (not saved).";
	break;
	}
	usual();
}
\content {.{Web Overview} {www("show", "http://info.cern.ch./hypertext/DataSources/bySubject/Overview.html");}
.{Web Project} {www("show", "http://info.cern.ch/hypertext/WWW/TheProject.html");}
.{Web Servers} {www("show", "http://info.cern.ch/hypertext/DataSources/WWW/Servers.html");}
.{\\}
.{Information By Subject} {www("show", "http://info.cern.ch/hypertext/DataSources/bySubject/Physics/HEP.html");}
.{WAIS Interface} {www("show", "http://info.cern.ch./hypertext/DataSources/WAIS/ByHost.html");}
.{Gopher Interface} {www("show", "gopher://gopher.micro.umn.edu:70/11/Other%20Gopher%20and%20Information%20Servers");}
.{HyTelnet Interface} {www("show", "http://info.cern.ch.:8002/w3start.txt");}
.{Techinfo Interface} {www("show", "http://info.cern.ch:8004/");}
.{Archie Interface} {www("show", "http://info.cern.ch:8001/archive.orst.edu:9000/archie-orst.edu");}
.{\\}
.{NCSA Home Page} {www("show", "http://hoohoo.ncsa.uiuc.edu/welcome.html");}
.{CERN Home Page} {www("show", "http://info.cern.ch/");}
.{Ohio State Home Page} {www("show", "http://www.cis.ohio-state.edu:80/hypertext/information/information.html");}
.{SLAC Home Page} {www("show", "http://slacvm.slac.stanford.edu./FIND/SLAC.HTML");}
.{HEP Overview} 
.{SIGGRAPH Bibliography} {www("show", "http://iicm.tu-graz.ac.at:80/CSIGGRAPHbib");}
.{Cornell Law School} {www("show", "http://fatty.law.cornell.edu.:80/usr2/wwwtext/lii.table.html");}
.{\\}
.{SunOS 4.1.1 Man Pages} {www("show", "http://www.cis.ohio-state.edu:80/man/sunos.top.html");}
.{HP/UX 8.0.7 Man Pages} {www("show", "http://www.cis.ohio-state.edu:80/man/hpux.top.html");}
.{Ultrix 4.2a Man Pages} {www("show", "http://www.cis.ohio-state.edu:80/man/ultrix.top.html");}
.{Pyramid OSx Man Pages} {www("show", "http://www.cis.ohio-state.edu:80/man/pyramid.top.html");}
.{AIX Man Pages} {www("show", "http://hoohoo.ncsa.uiuc.edu:1235/man/index");}
.{X11R5 Man Pages} {www("show", "http://www.cis.ohio-state.edu:80/man/x11.top.html");}
.{VMS Man pages} {www("show", "http://slacvx.slac.stanford.edu:80/HELP");}
.{\\}
.{Gopherspace Overview} gopher://gopher.micro.umn.edu:70/11/Other%20Gopher%20and%20Information%20Servers
.{\\}
.{NCSA Gopher} {www("show", "gopher://gopher.ncsa.uiuc.edu:70/1");}
.{CTC Gopher} {www("show", "gopher://gopher.tc.cornell.edu:70/1");}
.{PSC Gopher} {www("show", "gopher://pscuxb.psc.edu:1563/1");}
.{SDSC Gopher} {www("show", "gopher://gopher.sdsc.edu:70/1");}
.{\\}
.{UMN Gopher} {www("show", "gopher://gopher.micro.umn.edu:70/1");}
.{UIUC Gopher} {www("show", "gopher://gopher.uiuc.edu:70/1");}
}
\label {Public}
\BDColor {white}
\BGColor {grey45}
\FGColor {white}
\CRColor {grey75}
\font {normal}
\gapH {1}
\
\class {menu}
\name {www.top.files}
\parent {www.top}
\label {File}
\script {
/*\children {www.top.icon.xpm}*/
	switch (arg[0]) {
	case "quit":
		www("quit");
/*
		res.dialogWithButtons("show", "Really want to quit viola?",
					"Quit", "www(\"quit\");",
					"Cancel", "");
*/
		return;
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click to see some general project information.";
	break;
	}
	usual();
}
\menuConfig {
.{About ViolaWWW} {www("about");}
.{Help for ViolaWWW} {www("help");}
.{Version Info} {wwwAbout("visible", 1);}
.{\\}
.{Follow URL in selection buffer} {www("show", trimEdge(getSelection()));}
.{Show history list} {wwwHistory("render");}
.{Show document author contact} {www("authorContact");}
.{\\}
.{Quit} {send(self(), "quit");}
}
\maxWidth {60}
\BDColor {white}
\BGColor {grey45}
\FGColor {white}
\CRColor {white}
\font {normal}
\gapH {1}
\
\class {menu}
\name {www.top.options}
\parent {www.top}
\label {Options}
\script {
/*	switch (arg[0]) {
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Font changer.";
	break;
	}
*/
	usual();
}
\menuConfig {
.{Fonts}
..{Helvetica Small} {www("changeFonts", "useHelveticaSmallFonts");}
..{Helvetica Medium} {www("changeFonts", "useHelveticaMediumFonts");}
..{Helvetica Large} {www("changeFonts", "useHelveticaLargeFonts");}
..{\\}
..{Times Small} {www("changeFonts", "useTimesSmallFonts");}
..{Times Medium} {www("changeFonts", "useTimesMediumFonts");}
..{Times Large} {www("changeFonts", "useTimesLargeFonts");}
..{\\}
.{Search in headers} {www("searchByTag", "headers", "headers");}
.{Search in examples} {www("searchByTag", "examples", "examples");}
.{Search by commands} {www("searchByTag", "commands (CMD, KBD)", "commands");}
.{\\}
.{Dump document in HTML form (not yet)} {www("outputSGML");}
.{\\}
..{Fixed} {www("changeFonts", "useAllFixedFonts");}
}
\maxWidth {90}
\BDColor {white}
\BGColor {grey45}
\FGColor {white}
\CRColor {white}
\font {normal}
\gapH {1}
\
\class {generic}
\name {www.top.icon.xpm}
\parent {www.top.icon}
\script {
	switch (arg[0]) {
	case "buttonPress":
		send("www.top.icon", "buttonPress");
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click to see some general project information.";
	break;
	}
	usual();
}
\label {/* XPM */
static char * earthIconSmall1 [] = {
/* g30 pixmap
 * width height ncolors chars_per_pixel */
"22 22 7 1",
" 	s c0	c grey45",
".	s c23	c white",
"X	s c27	c #fbfbfb",
"o	s c46	c darkgreen",
"O	s c19	c lightblue",
"+	s c5	c blue",
"@	s c11	c brown",
/* pixels */
"       .X.XXX..       ",
"    o.OoooooOXXo..    ",
"   ..+++.oooXoXXO+.   ",
"  .+++X+oooooooo+++O  ",
" .++X+++ooXoooo+++.+  ",
" .++X++++ooXo@oo+O++. ",
" X++++++++o.o+OoO++++ ",
"+X+++++++++oOoooo++++.",
".+++++++++++++O..o.+++",
".+++++++++++++Ooooo++.",
".++++++++++++O+OooooX.",
".O+++++++++++.+oooooX.",
"..O+++++++++++o.ooXooo",
"..++++++++++++++ooooo.",
"+.+++++++++++++++oooo.",
" +++O+X+++++++++oooo. ",
" .+++++++++++++.Xoo+. ",
" .+++++++++++++Ooo++  ",
"  o+++++X++++++Oo.+.  ",
"   .o+++++++++oo..    ",
"    .+++XX+++o..      ",
"       .XXXXX..       "};
}
\width {22}
\height {22}
\x {12}
\y {2}
\BDColor {grey45}
\
\class {XBMButton}
\name {www.top.help}
\parent {www.top}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		www("help");
/*		www("show", "/usr/work/test.html");
*/
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click it to access a guide to this application.";
	break;
	}
	usual();
}
\label {#define help_width 32
#define help_height 32
static char help_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0xfc, 0x03, 0x00, 0x00, 0xff, 0x0f, 0x00, 0x80, 0xff, 0x1f, 0x00,
   0xc0, 0x0f, 0x3e, 0x00, 0xc0, 0x03, 0x38, 0x00, 0xe0, 0x03, 0x78, 0x00,
   0xe0, 0x07, 0x78, 0x00, 0xe0, 0x07, 0x78, 0x00, 0xc0, 0x07, 0x3c, 0x00,
   0x80, 0x03, 0x3c, 0x00, 0x00, 0x00, 0x3e, 0x00, 0x00, 0x00, 0x1f, 0x00,
   0x00, 0x80, 0x0f, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x01, 0x00,
   0x00, 0xe0, 0x00, 0x00, 0x00, 0xe0, 0x01, 0x00, 0x00, 0xe0, 0x01, 0x00,
   0x00, 0xe0, 0x01, 0x00, 0x00, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0xe0, 0x01, 0x00, 0x00, 0xf0, 0x03, 0x00, 0x00, 0xf0, 0x03, 0x00,
   0x00, 0xf0, 0x03, 0x00, 0x00, 0xe0, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
}
\maxWidth {32}
\BDColor {grey20}
\BGColor {grey45}
\FGColor {white}
\
\class {vpane}
\name {www.doc}
\parent {www}
\children {www.doc.tools www.doc.title www.doc.view www.doc.ctrl}
\script {
/*print("WWW>DOC arg[0]={", arg[0], "}\n");*/

	switch (arg[0]) {
	case "tear":
		tearPageID = tearPageID + 1;
		new = clone(tearPageID);
		tweak(new, "set(\"parent\", \"\");");
		send(new, "torn", send(nthChild(2), "whichPageP"));
		send(new, "render");
		return;
	break;
	case "torn":
		set("label", 
			send(send(nthChild(2), "whichPageP"), "queryAddress"));
		objectListSend_children("torn", arg[1]);
		return;
	break;
	case "init":
		tearPageID = 0;
	break;
	case "addTool":
	case "removeTool":
	case "destroyTool":
		return send(nthChild(0), arg[0], arg[1]);
	break;
	case "whichPageP":
		return send(nthChild(2), "whichPageP");
	break;
	case "outliner":
		if (arg[1]) {
			set("children", 
				"www.doc.title www.doc.view www.doc.ol www.doc.ctrl");
			send(self(), "configSelf");
			olP = 1;
		} else {
			set("children", 
				"www.doc.title www.doc.view www.doc.ctrl");
			send(self(), "configSelf");
			olP = 0;
		}
		return;
	break;
	case "quit":
/*		set("visible", 0);*/
		quit();
		return;
	break;
	case "init":
		usual();
		color = getResource("Viola.background_doc");
		if (color) {
			set("BGColor", color);
			set("BDColor", color);
		}
		return;
	break;
	}
	usual();
}
\width {400}
\height {400}
\BDColor {grey45}
\BGColor {grey45}
\
\class {hpane}
\name {www.doc.title}
\parent {www.doc}
\children {www.doc.title.tf}
\script {
	switch (arg[0]) {
	case "whichPageP":
		return send(parent(), arg[0]);
	break;
	}
	usual();
}
\maxHeight {38}
\BDColor {grey45}
\BGColor {LemonChiffon3}
\gapV {2}
\
\class {txtDisp}
\name {www.doc.title.tf}
\parent {www.doc.title}
\script {
	switch (arg[0]) {
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Document title. Click to reload document.";
	break;
	case "show":
		if (isBlank(arg[1])) {
/*			set("content", "<No Title>");*/
			set("content", "");
		} else {
			if (textWidth(5/*bold_large*/, arg[1])+10 < width()) {
				/*set("font", "bold_largest");*/
				set("content", concat("\\f(5)", arg[1]));
			} else {
				/* this is so broken
				set("font", "bold");
				*/
				set("content", concat("\\f(4)", arg[1]));
			}
		}
		render();
		return;
	break;
	case "buttonRelease":
		send(send(get("parent"), "whichPageP"), "reload");
	break;
	case "torn":
		return;
	break;
	case "init":
		usual();
		color = getResource("Viola.background_toolbar");
		if (color) {
			set("BGColor", color);
			set("BDColor", color);
		}
		return;
	break;
	}
	usual();
}
\content {this is where the page title goes}
\BDColor {LemonChiffon3}
\BGColor {LemonChiffon3}
\FGColor {black}
\gapV {1}
\gapH {2}
\font {bold_large}
\format {1}
\
\class {XPM}
\name {www.doc.title.icon}
\parent {www.doc.title}
\script {
	switch (arg[0]) {
	case "group":
		return 0;
/*
		switch (arg[1]) {
		case "ora/xlib":
			set("label", 
				loadFile(concat(environVar("VIOLA_DOCS"), "/",
					        "icons_ora_xlib.xpm")));
			render();
		break;
		case "ora/gnn":
			set("label", 
				loadFile(concat(environVar("VIOLA_DOCS"), "/",
					        "icons_ora_gnn.xpm")));
			render();
		break;
		case "man":
			set("label", 
				loadFile(concat(environVar("VIOLA_DOCS"), "/",
					        "icons_man.xpm")));
			render();
		break;
		case "www":
		default:
			set("label", 
				loadFile(concat(environVar("VIOLA_DOCS"), "/",
					        "icons_www.xpm")));
			render();
		break;
		}
*/
	break;
	}
	usual();
}
\gapH {2}
\gapV {1}
\maxWidth {34}
\BDColor {black}
\
\class {hpane}
\name {www.doc.tools}
\parent {www.doc}
\children {www.doc.tools.dyna www.doc.tools.ops www.doc.tools.sys www.doc.tools.pad}
\script {

	switch (arg[0]) {
	case "addTool":
	case "addTool_sticky":
	case "removeTool":
	case "destroyTool":
		return send(nthChild(0), arg[0], arg[1]);
	break;
	case "clear":
		return send(nthChild(0), arg[0]);
	break;
	case "init":
		usual();
		color = getResource("Viola.background_toolbar");
		if (color) {
			set("BGColor", color);
			set("BDColor", color);
		}
		return;
	break;
	}
	usual();
}
\BDColor {black}
\BGColor {grey45}
\maxHeight {33}
\gapH {-1}
\
\class {hpane}
\name {www.doc.tools.dyna}
\parent {www.doc.tools}
\script {
/*print("WWW>DOC>TOOLS>DYNA arg[0]={", arg[0], "}\n");*/

	switch (arg[0]) {
	case "addTool":
	case "addTool_sticky":
		new = object(arg[1]);
		for (i = objectListCount_children(); i >= 0; i--) 
			if (nthChild(i) == new) return 1;
		objectListAppend("children", new);
		tweak(new, concat("set(\"parent\", \"", self(), "\");"));
		send(new, "visible", 1);
		config();
		return 1;
	break;
	case "removeTool":
		new = object(arg[1]);
		objectListDelete("children", new);
		send(new, "visible", 0);
		config();
		return 1;
	break;
	case "destroyTool":
		new = object(arg[1]);
		objectListDelete("children", new);
		send(new, "visible", 0);
		send(new, "freeSelf");
		config();
		return 1;
	break;
	case "clear":
		set("children", "");
		return;
	break;
	case "go_url":
		return send("www", "show", arg[1]);
	break;
	case "go_home":
		return send("www", "home");
	break;
	case "go_prev":
		return send("www", "prev");
	break;
	case "go_next":
		return send("www", "next");
	break;
	case "go_back":
		return send("www", "back");
	break;
	case "init":
		usual();
		color = getResource("Viola.background_toolbar");
		if (color) {
			set("BGColor", color);
			set("BDColor", color);
		}
		return;
	break;
	}
	usual();
}
\BDColor {grey45}
\BGColor {grey45}
\
\class {hpane}
\name {www.doc.tools.ops}
\parent {www.doc.tools}
\children {www.doc.tools.ops.reload www.doc.tools.ops.clone}
\paneConfig {eastToWest}
\script {
/*print("WWW>DOC>TOOLS>ops arg[0]={", arg[0], "}\n");*/

	switch (arg[0]) {
	case "init":
		usual();
		color = getResource("Viola.background_toolbar");
		if (color) {
			set("BGColor", color);
			set("BDColor", color);
		}
		return;
	break;
	}
	usual();
}
\maxWidth {62}
\gapH {3}
\BDColor {grey45}
\BGColor {grey45}
\
\class {XPMButton}
\name {www.doc.tools.ops.reload}
\parent {www.doc.tools.ops}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send("www", "reload");
	break;
	case "enter":
	case "leave":
		send("www.mesg.tf", "suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click to reload the document";
	break;
	}
	usual();
}
\label {/* XPM */
static char * reload [] = {
"32 32 6 1",
" 	s None	c None",
".	c black",
"X	c white",
"o	c gray",
"O	c gray30",
"+	c red",
"............................... ",
".XXXXXXXXXXXXXXXXXXXXXXXXXXXXX. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".Xooooooo...........oooooooooO. ",
".Xooooooo.XXXXXXXX.X.ooooooooO. ",
".Xoooo+++.X......X.XX.oooooooO. ",
".Xoooo+++.XXXXXXXX.XXX.ooooooO. ",
".Xoooo+...X......X.....ooooooO. ",
".Xoooo+++.XXXXXXXXXXXX.ooooooO. ",
".Xoooo+...X.........XX.ooooooO. ",
".Xoooo+++.XXXXXXXXXXXX.ooooooO. ",
".Xoooo+...X.........XX.ooooooO. ",
".Xoooo+++.XXXXXXXXXXXX.ooooooO. ",
".Xoooo+...X.........XX.ooooooO. ",
".Xoooo+++.XXXXXXXXXXXX.ooooooO. ",
".Xoooo+................ooooooO. ",
".Xoooo++++++++++++++oooooooooO. ",
".Xoooo+...........++oooooooooO. ",
".Xoooo++++++++++++++oooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".Xoo...Oo...o.ooO.OoO.Oo..oooO. ",
".Xoo.oo.o.ooo.oo.o.o.O.o.o.ooO. ",
".Xoo...Oo..oo.oo.o.o.o.o.o.ooO. ",
".Xoo.o.oo.ooo.oo.o.o...o.o.ooO. ",
".Xoo.oo.o.ooo.oo.o.o.o.o.o.ooO. ",
".Xoo.oo.o...o..oO.Oo.o.o..oooO. ",
".XoooooooooooooooooooooooooooO. ",
".XOOOOOOOOOOOOOOOOOOOOOOOOOOOO. ",
"............................... ",
"                                "};}
\maxWidth {31}
\BDColor {grey45}
\BGColor {grey45}
\
\class {XPMButton}
\name {www.doc.tools.ops.clone}
\parent {www.doc.tools.ops}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send("www", "tear");
	break;
	case "enter":
	case "leave":
		send("www.mesg.tf", "suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click to reload the document";
	break;
	}
	usual();
}
\label {/* XPM */
static char * clone [] = {
"32 32 5 1",
" 	s None	c None",
".	c black",
"X	c white",
"o	c gray",
"O	c gray30",
"............................... ",
".XXXXXXXXXXXXXXXXXXXXXXXXXXXXX. ",
".XoooooooooooooooooooooooooooO. ",
".Xooo..........ooooooooooooooO. ",
".Xooo.XXXXXXX.X.oooooooooooooO. ",
".Xooo.X....XX.XX.ooooooooooooO. ",
".Xooo.XXXXXXX.XXX.oooooooooooO. ",
".Xooo.X.....X.....oooooooooooO. ",
".Xooo.XXXXXXXXXXX.oooooooooooO. ",
".Xooo.X......X.........ooooooO. ",
".Xooo.XXXXXXXX.XXXXXX.X.oooooO. ",
".Xooo.X......X.X...XX.XX.ooooO. ",
".Xooo.XXXXXXXX.XXXXXX.XXX.oooO. ",
".Xooo.X......X.X....X.....oooO. ",
".Xooo.XXXXXXXX.XXXXXXXXXX.oooO. ",
".Xooo.XXXXXXXX.X........X.oooO. ",
".Xooo..........XXXXXXXXXX.oooO. ",
".Xoooooooooooo.X........X.oooO. ",
".Xoooooooooooo.XXXXXXXXXX.oooO. ",
".Xoooooooooooo.XXXXXXXXXX.oooO. ",
".Xoooooooooooo............oooO. ",
".XoooooooooooooooooooooooooooO. ",
".Xooooo..o.oo...o.Oo.o...ooooO. ",
".Xoooo.Ooo.oo.o.o..o.o.ooooooO. ",
".Xoooo.ooo.oo.o.o.o..o..oooooO. ",
".Xoooo.ooo.oo.o.o.oO.o.ooooooO. ",
".Xoooo.Ooo.oo.o.o.oo.o.ooooooO. ",
".Xooooo..o..o...o.oo.o...ooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XOOOOOOOOOOOOOOOOOOOOOOOOOOOO. ",
"............................... ",
"                                "};}
\maxWidth {31}
\BDColor {grey45}
\BGColor {grey45}
\
\class {hpane}
\name {www.doc.tools.sys}
\parent {www.doc.tools}
\children {www.doc.tools.sys.prev www.doc.tools.sys.back www.doc.tools.sys.next www.doc.tools.sys.home}
\paneConfig {eastToWest}
\script {
/*print("WWW>DOC>TOOLS>sys arg[0]={", arg[0], "}\n");*/

	switch (arg[0]) {
	case "addTool":
	case "addTool_sticky":
		new = object(arg[1]);
		for (i = objectListCount_children(); i >= 0; i--) 
			if (nthChild(i) == new) return 1;
		objectListAppend("children", new);
		tweak(new, concat("set(\"parent\", \"", self(), "\");"));
		send(new, "visible", 1);
		config();
		return 1;
	break;
	case "removeTool":
		new = object(arg[1]);
		objectListDelete("children", new);
		send(new, "visible", 0);
		config();
		return 1;
	break;
	case "destroyTool":
		new = object(arg[1]);
		objectListDelete("children", new);
		send(new, "visible", 0);
		send(new, "freeSelf");
		config();
		return 1;
	break;
	case "init":
		usual();
		color = getResource("Viola.background_toolbar");
		if (color) {
			set("BGColor", color);
			set("BDColor", color);
		}
		return;
	break;
	}
	usual();
}
\maxWidth {133}
\gapH {3}
\BDColor {grey45}
\BGColor {grey45}
\
\class {XPMButton}
\name {www.doc.tools.sys.prev}
\parent {www.doc.tools.sys}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send("www", "prev");
	break;
	case "enter":
	case "leave":
		send("www.mesg.tf", "suggest", get("name"), arg[0]);
		encounter = enconter + 1;
		return;
	break;
	case "hint":
		return concat("Click to visit the previous document = ",
				wwwHistory("peek_prev"));
	break;
	}
	usual();
}
\label {/* XPM */
static char * prev [] = {
"32 32 7 1",
" 	s None	c None",
".	c black",
"X	c white",
"o	c grey75",
"O	c gray30",
"+	c gray",
"@	c gray50",
"............................... ",
".XXXXXXXXXXXXXXXXXXXXXXXXXXXXX. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".Xooooooooooooo+oooooooooooooO. ",
".Xooooooooooooo+++oooo...ooooO. ",
".Xoooooooooooo++++++..@@.ooooO. ",
".Xooooooooooo+++++..@@@@.ooooO. ",
".Xoooooooooo++++..@@@@@@.ooooO. ",
".Xooooooooooo+..@@@@@@@@.ooooO. ",
".Xoooooooooo..@@@@@@@@@@.ooooO. ",
".Xoooooo+o..@@@@@@@@@@@@.ooooO. ",
".Xoooooo..@@@@@@@@@@@@@@.ooooO. ",
".Xoooo+.@@@@@@@@@@@@@@@@.+oooO. ",
".Xoooooo..@@@@@@@@@@@@@@.ooooO. ",
".Xoooooooo..@@@@@@@@@@@@.ooooO. ",
".Xoooooooo++..@@@@@@@@@@.ooooO. ",
".Xoooooo++++++..@@@@@@@@.ooooO. ",
".Xoooooo++++++++..@@@@@@.ooooO. ",
".Xoooooo++++++++++..@@@@.ooooO. ",
".Xoooooo++++++++++++..@@.ooooO. ",
".Xoooooo++++++++++++++...ooooO. ",
".Xoooo+++++++++++++++++++ooooO. ",
".Xooooo++ooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XOOOOOOOOOOOOOOOOOOOOOOOOOOOO. ",
"............................... ",
"                                "};}
\maxWidth {31}
\BDColor {grey45}
\BGColor {grey45}
\
\class {XPMButton}
\name {www.doc.tools.sys.back}
\parent {www.doc.tools.sys}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send("www","back");
	break;
	case "enter":
	case "leave":
		send("www.mesg.tf", "suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return concat("Click to go back. document = ",
				send("wwwHistory", "peek_back"));
	break;
	}
	usual();
}
\label {/* XPM */
static char * back [] = {
"32 32 7 1",
" 	s None	c None",
".	c black",
"X	c white",
"o	c gray",
"O	c gray30",
"+	c gray50",
"@	c grey75",
"............................... ",
".XXXXXXXXXXXXXXXXXXXXXXXXXXXXX. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".Xooooooooooooo.oooooooooooooO. ",
".Xoooooooooooo.+.ooooooooooooO. ",
".Xoooooooooooo.+.ooooooooooooO. ",
".Xooooooooooo.+++.oooooooooooO. ",
".Xooooooooooo.+++.oooooooooooO. ",
".Xoooooooooo.+++++.ooooooooooO. ",
".Xoooooooooo.+++++.ooooooooooO. ",
".Xooooooooo.+++++++.oooooooooO. ",
".Xooooooooo.+++++++.oooooooooO. ",
".Xoooooooo.+++++++++.ooooooooO. ",
".Xoooooooo.+++++++++.ooooooooO. ",
".Xooooooo.+++++++++++.oooooooO. ",
".Xooooooo.+++++++++++.oooooooO. ",
".Xoooooo.+++++++++++++.ooooooO. ",
".Xoooooo.+++++++++++++.ooooooO. ",
".Xooooooo.............oooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".Xoooo...oooo.oooo..o.oo.ooooO. ",
".Xoooo.o.ooo.o.oo.ooo.o.oooooO. ",
".Xoooo....oo...oo.ooo..ooooooO. ",
".Xoooo.oo.o.ooo.o.ooo.@.oooooO. ",
".Xoooo...oo.ooo.oo..o.oo.ooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XOOOOOOOOOOOOOOOOOOOOOOOOOOOO. ",
"............................... ",
"                                "};}
\maxWidth {31}
\BDColor {grey45}
\BGColor {grey45}
\
\class {XPMButton}
\name {www.doc.tools.sys.next}
\parent {www.doc.tools.sys}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		www("next");
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return concatenate("Click to visit the next document = ",
				wwwHistory("peek_next"));
	break;
	}
	usual();
}
\label {/* XPM */
static char * next [] = {
"32 32 7 1",
" 	s None	c None",
".	c black",
"X	c white",
"o	c grey75",
"O	c gray30",
"+	c gray",
"@	c gray50",
"............................... ",
".XXXXXXXXXXXXXXXXXXXXXXXXXXXXX. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".Xooooooooooooo+oooooooooooooO. ",
".Xooooo...oooo+++ooooooooooooO. ",
".Xooooo.@@..++++++oooooooooooO. ",
".Xooooo.@@@@..+++++ooooooooooO. ",
".Xooooo.@@@@@@..++++oooooooooO. ",
".Xooooo.@@@@@@@@..+ooooooooooO. ",
".Xooooo.@@@@@@@@@@..oooooooooO. ",
".Xooooo.@@@@@@@@@@@@..o+oooooO. ",
".Xooooo.@@@@@@@@@@@@@@..oooooO. ",
".Xoooo+.@@@@@@@@@@@@@@@@.+oooO. ",
".Xooooo.@@@@@@@@@@@@@@..oooooO. ",
".Xooooo.@@@@@@@@@@@@..oooooooO. ",
".Xooooo.@@@@@@@@@@..++oooooooO. ",
".Xooooo.@@@@@@@@..++++++oooooO. ",
".Xooooo.@@@@@@..++++++++oooooO. ",
".Xooooo.@@@@..++++++++++oooooO. ",
".Xooooo.@@..++++++++++++oooooO. ",
".Xooooo...++++++++++++++oooooO. ",
".Xoooo+++++++++++++++++++ooooO. ",
".Xooooo++ooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XOOOOOOOOOOOOOOOOOOOOOOOOOOOO. ",
"............................... ",
"                                "};}
\maxWidth {31}
\BDColor {grey45}
\BGColor {grey45}
\
\class {XPMButton}
\name {www.doc.tools.sys.home}
\parent {www.doc.tools.sys}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send("www","home");
	break;
	case "enter":
	case "leave":
		send("www.mesg.tf", "suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click the house icon to visit home page.";
	break;
	}
	usual();
}
\label {/* XPM */
static char * home [] = {
"32 32 8 1",
" 	s None	c None",
".	c black",
"X	c white",
"o	c grey75",
"O	c gray30",
"+	c gray",
"@	c red",
"#	c maroon",
"............................... ",
".XXXXXXXXXXXXXXXXXXXXXXXXXXXXX. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".Xoo++++++++++++++++++++++++oO. ",
".Xoo++++++++++++++++++++++++oO. ",
".Xoo++++++++@@@@@@@+++++++++oO. ",
".Xoo+++++++@##@@@@@@++++++++oO. ",
".Xoo+++++++@###@@@@@++++++++oO. ",
".Xoo++++++@####@@@@@@+++++++oO. ",
".Xoo+++++@######@@@@@@++++++oO. ",
".Xoo++++@########@@@@@++++++oO. ",
".Xoo++++@#########@@@@@+++++oO. ",
".Xoo+++@##########@@@@@@++++oO. ",
".Xoo++@+###########@@@@@++++oO. ",
".Xoo++++###########.###+++++oO. ",
".Xoo++++####...########+++++oO. ",
".Xoo++++####...####.###+++++oO. ",
".Xoo++++####...########+++++oO. ",
".Xoo++++####...####.###+++++oO. ",
".Xoo++++####...########+++++oO. ",
".Xoo++++####...####.##++++++oO. ",
".Xoo++++####...#####++++++++oO. ",
".Xoo++++++++++++++++++++++++oO. ",
".Xoo++++++++++++++++++++++++oO. ",
".Xoo++++++++++++++++++++++++oO. ",
".Xoo++++++++++++++++++++++++oO. ",
".Xoo++++++++++++++++++++++++oO. ",
".XoooooooooooooooooooooooooooO. ",
".XOOOOOOOOOOOOOOOOOOOOOOOOOOOO. ",
"............................... ",
"                                "};}
\maxWidth {31}
\BDColor {grey45}
\BGColor {grey45}
\gapH {-1}
\
\class {field}
\name {www.doc.tools.pad}
\parent {www.doc.tools}
\BDColor {grey45}
\BGColor {grey45}
\maxWidth {4}
\
\class {hpane}
\name {www.doc.view}
\parent {www.doc}
\gapH {2}
\children {www.doc.view.pane www.doc.view.sb}
\script {
	switch (arg[0]) {
	case "tear":
	case "quit":
		send(get("parent"), arg[0]);
		return;
	break;
	case "torn":
		send(send(nthChild(0), "torn", arg[1]));
		pagePane = get("content");
		return;
	break;
	case "whichPageP":
		return send(pagePane, "whichPageP");
	break;
	case "key_up":
		send("www.doc.view.sb.slider", "scroll", "up");
		return;
	break;
	case "key_down":
		send("www.doc.view.sb.slider", "scroll", "down");
		return;
	break;
	case "addTool":
	case "removeTool":
	case "destroyTool":
		return send(parent(), arg[0], arg[1]);
	break;
	case "sliderConfig":
		switch (arg[1]) {
		case "left":
			set("children", "www.doc.view.sb www.doc.view.pane");
			send(self(), "configSelf");
			send("www.doc.view.sTUb", "getLost");
			pagePane = nthChild(1);
			send("www.doc.view.pane", "configSiderGeom");
		break;
		case "right":
			set("children", "www.doc.view.pane www.doc.view.sb");
			send(self(), "configSelf");
			send("www.doc.view.sTUb", "getLost");
			pagePane = nthChild(0);
			send("www.doc.view.pane", "configSiderGeom");
		break;
		case "none":
			set("children", "www.doc.view.pane www.doc.view.sTUb");
			send("www.doc.view.sTUb", "showYaSelf");
			send(self(), "configSelf");
			pagePane = nthChild(0);
		break;
		}
		set("content", pagePane);
		return;
	break;
	case "init":
		usual();
		pagePane = nthChild(0); /* default scrolbar at right side */
		set("content", pagePane);
		color = getResource("Viola.background_doc");
		if (color) set("BGColor", color);
		return;
	break;
	}
	usual();
}
\BDColor {grey45}
\BGColor {LemonChiffon1}
\
\class {field}
\name {www.doc.view.sTUb}
\parent {www.doc.view}
\script {
	switch (arg[0]) {
	case "showYaSelf":
		set("visible", 1);
		return;
	break;
	case "getLost":
		set("visible", 0);
		return;
	break;
	}
	usual();
}
\maxWidth {20}
\BDColor {grey45}
\BGColor {grey45}
\
\class {vpane}
\name {www.doc.view.sb}
\parent {www.doc.view}
\children {www.doc.view.sb.up www.doc.view.sb.down www.doc.view.sb.slider}
\script {
/*
	switch (arg[0]) {
	case "tear":
	case "quit":
		send(get("parent"), arg[0]);
		return;
	break;
	case "torn":
		send(nthChild(0), "torn");
		return;
	break;
	}
*/
	usual();
}
\maxWidth {20}
\BDColor {55 55 55}
\BGColor {25 25 25}
\FGColor {99 99 99}
\
\class {XPMButton}
\name {www.doc.view.sb.up}
\parent {www.doc.view.sb}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send(nthSibling(2), "scroll", "up");
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click to scroll up one page.";
	break;
	}
	usual();
}
\label {/* XPM */
static char * upArrowButton [] = {
"20 20 4 1",
" 	c gray50",
".	c white",
"X	c black",
"o	c grey75",
"                    ",
"         .X         ",
"         .X         ",
"        ..XX        ",
"        ..oX        ",
"       ..ooXX       ",
"       ..oooX       ",
"      ..ooooXX      ",
"      ..oooooX      ",
"     ..ooooooXX     ",
"     ..oooooooX     ",
"    ..ooooooooXX    ",
"    ..oooooooooX    ",
"   ..ooooooooooXX   ",
"   ..oooooooooooX   ",
"  ..ooooooooooooXX  ",
"  ..oooooooooooooX  ",
" ..ooooooooooooooXX ",
" .XXXXXXXXXXXXXXXXX ",
"                    "};
}
\maxHeight {19}
\BDColor {grey75}
\
\class {XPMButton}
\name {www.doc.view.sb.down}
\parent {www.doc.view.sb}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send(nthSibling(2), "scroll", "down");
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click to scroll down one page.";
	break;
	}
	usual();
}
\label {/* XPM */
static char * downArrowButton [] = {
"20 20 4 1",
" 	c gray50",
".	c white",
"X	c black",
"o	c grey75",
"                    ",
" .................X ",
" ..ooooooooooooooXX ",
"  ..oooooooooooooX  ",
"  ..ooooooooooooXX  ",
"   ..oooooooooooX   ",
"   ..ooooooooooXX   ",
"    ..oooooooooX    ",
"    ..ooooooooXX    ",
"     ..oooooooX     ",
"     ..ooooooXX     ",
"      ..oooooX      ",
"      ..ooooXX      ",
"       ..oooX       ",
"       ..ooXX       ",
"        ..oX        ",
"        ..XX        ",
"         .X         ",
"         .X         ",
"                    "};
}
\maxHeight {19}
\BDColor {grey75}
\
\class {slider}
\name {www.doc.view.sb.slider}
\parent {www.doc.view.sb}
\shownNotify {www.doc.view.pane}
\script {
	switch (arg[0]) {
	case "setShownNotify":
		set("shownNotify", arg[1]);
		return;
	break;
	case "kludgeRender":
		/* This is a kludge to get around a BUG */
		return after(1, self(), "render");
	break;
	}
	usual();
}
\BDColor {white}
\BGColor {grey45}
\FGColor {grey75}
\
\class {vpane}
\name {www.doc.view.sb2}
\parent {www.doc.view}
\children {www.doc.view.sb2.slider}
\maxWidth {20}
\
\class {slider}
\name {www.doc.view.sb2.slider}
\parent {www.doc.view.sb2}
\shownNotify {www.doc.view.pane}
\BDColor {grey75}
\BGColor {grey45}
\FGColor {grey99}
\
\class {field}
\name {www.doc.view.pane}
\parent {www.doc.view}
\shownDepend {www.doc.view.sb.slider}
\script {
/*print("PANE: ");
for (i=0; i < arg[]; i++) print("arg", i, " = ", arg[i], "\n");
print("\n");
*/
	switch (arg[0]) {
	case "shownPositionV":
		return send(pageObj, "shownPositionV", arg[1]);
	break;
	case "procratinate_show":
		stat = send("www.doc.view.pane", "show", arg[1]);
		if (stat == 0) after(1000, self(), "procratinate_show",arg[1]);
		else send("www.doc.view.pane", "historyRecord");
		return;
	break;
	case "show":
	case "post":
		if (arg[0] == "post") {
			doPost = 1;
			postData = arg[3];
		} else { 
			doPost = 0;
			postData = 0;
		}
		if (torn == 1) {
			if (arg[] == 2)
				return send("www.doc.view.pane", 
					    arg[0], arg[1]);
			else if (arg[] == 3)
				return send("www.doc.view.pane", 
					    arg[0], arg[1], arg[2]);
			else	return send("www.doc.view.pane", 
					    arg[0], arg[1], arg[2], arg[3]);
		}
		if (nthChar(arg[1], 0) == '#') {	
			pageYPos = send(pageObj, "gotoAnchor", 
					nthChar(arg[1], 1, 999));

			pageHeight = send(pageObj, "vspan");
			heightDiff = pageHeight - get("height");
			heightRatio =  float(heightDiff) / -100.0;

			if (heightDiff > 0) {
				sliderSize = float(get("height")) / 
						float(pageHeight) * 100;
				sliderPos = float(pageYPos) / 
						float(heightDiff) * 100;
				if (sliderPos > 100) sliderPos = 100;
			} else {
				sliderSize = 100;
				sliderPos = 0;
			}
			send(pageObj, "shownPositionV", sliderPos);
			objectListSend("shownDepend", "_shownInfoV", 
					sliderPos, sliderSize);
			objectListSend("shownDepend", "setShownNotify",
					pageObj);
		} else {
			if (arg[] == 2) 
				normURL = send("normalizeURL", "normalizeURL",
						arg[1]);
			else 
				normURL = send("normalizeURL", "normalizeURL",
						arg[1], arg[2]);

			oldDocName = docName;
			docName = normURL;
			docURL = normURL;
			if (get("width") <= 1) {
				after(1000, self(), 
					"procratinate_show", normURL);
				return 0;
			}
			if (findPattern(arg[1], "telnet:") != -1) {
				cmd = send("WWWTelnetHandler", "connect", 
						normURL);
				www.mesg.tf("warn", cmd);
				system(cmd);
				return normURL;
			} else if (findPattern(arg[1], "mailto:") != -1) {
				subject = concat("WWW mail from: ", 
						ormalizedURL);
				tt = arg[1];
				i = findPattern(tt, "/");
				if (i == -1) {
					address = nthChar(tt, 7, 999);
					content = concat(
				"This mail was generated by WWW URL:\n",
						   tt, "\n");
				} else {
					address = nthChar(tt, 7, i-1);
					content = concat(nthChar(tt, io1, 999),
							 "\n");
				}
				tmpFile = makeTempFile();
				saveFile(tmpFile, content);

				cmd = concat("mail -s \"", subject,
					     "\" ", address, " < ", tmpFile);
				system(cmd);
				system(concat("rm ", tmpFile));
				return normURL;
			}
			anchor = parseHTTPAddress("anchor", normURL);
			if (exist(docName) == 1) {
				set("children", docName);
				if (anchor != "")  {
					if (findPattern(docURL, ".hmml") > -1){
						pageYPos = send(docName, 
								"gotoAnchor",
								 anchor) * -1;
						send(docName, "y", pageYPos);
					}
				} else {
					pageYPos = send(docName, "yP");
				}
				send(docName, "display", width(), height());
			} else {
				/* a rough guess at the document type */
				handler = wwwFormatDetect("type", docURL);
				send("www.mesg.tf", "show", 
					    concat("Getting ", docURL));

				if (torn == 1) paneObj = "www.doc.view.pane";
				else paneObj = self();

				docObj = send("wwwHandlerDispatch", 
						"dispatch", handler,
						doPost, docURL,
						docName, paneObj,
						get("width"), get("height"),
						anchor, 1, postData);
				cursorShape("idle");

				if (docObj == 0) {
					if (exist("www.mesg.tf"))
						www.mesg.tf("show",
						 concat("Failed ", docURL));
					winPos = windowPosition();
					res.dialogWithButtons("showAt", 
						winPos[0] + 20, winPos[1] + 20,
						500, 80,
						concat("Failed to access\n", 
							docURL),
						"Dismiss", "");
					return 0;
				} else if (docObj == 1) {
		/* It's OK.. no doc object generated but wasn't an error 
		 * (ie: to be rendered by external viewer) */
					return 0;
				}
				if (insertObjCount > 0) {
					for (i = 0; i < insertObjCount; i++)
						send(insertObj[i], "insert");
					insertObjCount = 0;
					send(self(), 'R',
						get("y"), get("width"));
				}
				send(docName, "display", 
						get("width"), get("height"));
				send(docName, "show");
				pageYPos = send(docName, "yP");
			}
			oo = object(docName);
			if (oldDocName != docName) {
				if (pageObj) {
					send(pageObj, "VW_event", "VIEW_OFF");
				}
				pageObj = oo;
				send(pageObj, "VW_event", "VIEW_ON");
			} else {
				pageObj = oo;
			}
			pageHeight = send(pageObj, "vspan");
			send(self(), "configShare");
		}

		title = send(pageObj, "queryTitle");
		if (isBlank(title)) title = pageObj;
		www.doc.title.tf("show", title);

		www.url.tf("show", send(pageObj, "queryAddress"));

		indexP = send(pageObj, "queryIsIndex");
		www.doc.ctrl.label("index", indexP);
		www.doc.ctrl.tf("index", indexP);

		return docName;
	break;
	case "toDoInsert":
		insertObj[insertObjCount] = arg[1];
		insertObjCount = insertObjCount + 1;
		return;
	break;
	case "show_request_by_child":
	case "post_request_by_child":
		cursorShape("busy");

		if (arg[0] == "post_request_by_child") realMesg = "post";
		else realMesg = "show";

		if (torn == 1) destObj = self();
		else destObj = object("www");

		if (arg[] == 3) stat = send(destObj, realMesg, arg[1], arg[2]);
		else stat = send(destObj, realMesg, arg[1], arg[2], arg[3]);

		if (stat) stat = send("www.doc.view.pane", "historyRecord");

		cursorShape("idle");
		return stat;
	break;
	case "hintOn":
		www.mesg.tf("show", arg[1]);
		return;
	break;
	case "hintOff":
		www.mesg.tf("clear");
		return;
	break;
	case "setChildren":
		set("children", arg[1]);
		return;
	break;
	case "configShare":
		heightDiff = pageHeight - get("height");
		heightRatio =  float(heightDiff) / -100.0;
		if (heightDiff > 0) {
		  sliderSize = float(get("height")) / float(pageHeight) * 100;
		  sliderPos = float(pageYPos) / float(heightDiff) * -100;
		} else {
		  sliderSize = 100;
		  sliderPos = 0;
		}
		objectListSend("shownDepend", "_shownInfoV", 
				sliderPos, sliderSize);
		objectListSend("shownDepend", "setShownNotify", pageObj);
		return;
	break;
	case "configSliderGeom":
		pageHeight = send(pageObj, "vspan");
		send(self(), "configShare");
		return;
	break;
	case "config":
		usual();
		/* ask page object to do the calculation */
		send(pageObj, "resize", get("width"), get("height"));
		pageYPos = send(pageObj, "yP");
		pageHeight = send(pageObj, "vspan");
		if (pageYPos + pageHeight < get("height")) {
			pageYPos = get("height") - pageHeight;
			send(pageObj, "y", pageYPos);
		}
		send(self(), "configShare");

		/* this call should not be necessary */
		objectListSend("shownDepend", "kludgeRender");

		return;
	break;
	case "update":
		pageObj = nthChild(0);
		pageHeight = arg[1];
		send(self(), "configShare");
		return;
	break;
	case "destroyDoc":
	case "destroyDoc_qualified":
		send(pageObj, "VW_event", "VIEW_OFF");
		send(pageObj, "visible", 0);
		send(pageObj, "freeSelf");
		pageObj = 0;
		return;
	break;
	case "addTool":
	case "removeTool":
	case "destroyTool":
		return send(parent(), arg[0], arg[1]);
	break;
	case "search":
		return send(pageObj, "search", arg[1]);
	break;
	case "searchByTag":
		/* arg[1]	english desc of searching field
		 * arg[2]	tag(set)
		 */
		send("res.getLineEntry", "show", 
			concat("Enter keyword to search in ", arg[1], '.'),
			"", self(), "searchByTag_specified");
		return;
	break;
	case "searchByTag_specified":
		/* arg[1]	tag
		 * arg[2]	keyword
		 */
		return send(pageObj, "searchByTag", arg[1], arg[2]);
	break;
	case "outputSGML":
		print("-------------\nTHIS FACILITY IS NOT YET WORKING\n");
		send(pageObj, "outputSGML");
		print("-------------\n");
		return;
	break;
	case "mailToAuthor":
		contactURL = send(pageObj, "queryAuthor");
		if (contactURL) {
			res.dialogWithButtons("show", 
			 concat("The declared author contact is:\n", 
				contactURL),
			 "Dismiss", "");
		} else {
			res.dialogWithButtons("show", 
			 "Sorry, no author contact declared in the document.",
			 "Dismiss", "");
		}
		return;
	break;
	case "reload":
	case "clone":
		return send(nthChild(0), arg[0]);
	break;
	case "whichPageP":
		return nthChild(0);
	break;
	case "heightP":
		return height();
	break;
	case "expose":
/* Trap this event to inhibit the default behavior to re-arrange geometry
 * which would cause uncessary reloading of HTML docs (b/c children would
 * get config messages). We still want to use hpane here because we do want to
 * reload (to reformat) HTML docs if width is changed.
 */
		if (todo) {
			homeDoc = www("homeDocP");
			www("show", homeDoc);
/*send(homeDoc, "show");send(homeDoc, "deepSetData");
send(homeDoc, "tile", 0, get("width"), get("height"));
*/
			todo = 0;
		}
		return;
	break;
	case "historyRecord":
		send(pageObj, "historyRecord");
		return;
	break;
	case "reportNextID":
		return;
	break;
	case "init":
		usual();
		todo = 0;
		color = getResource("Viola.background_doc");
		if (color) set("BGColor", color);
		return;
	break;
	case "torn":
		/* arg[1]	orig object */
		torn = 1;
		send(nthChild(0), "torn", arg[1]);
		pageObj = nthChild(0);
		/* make self reset variables */
		send(self(), "update", send(pageObj, "vspan"));
		return;
	break;
	}
	usual();
}
\BGColor {LemonChiffon1}
\BDColor {black}
\
\class {hpane}
\name {www.doc.ctrl}
\parent {www.doc}
\children {www.doc.ctrl.label www.doc.ctrl.tf www.doc.ctrl.prt www.doc.ctrl.reload www.doc.ctrl.src www.doc.ctrl.out2File www.doc.ctrl.tear}
\maxHeight {18}
\script {
	switch (arg[0]) {
	case "whichPageP":
		return send(get("parent"), "whichPageP");
	break;
	case "tear":
	case "quit":
		send(get("parent"), arg[0]);
		return;
	break;
	case "torn":
		/* inform www.doc.ctrl.clone to change icon */
		send(nthChild(6), "torn");
		return;
	break;
	}
	usual();
}
\BDColor {grey45}
\
\class {txtLabel}
\name {www.doc.ctrl.label}
\parent {www.doc.ctrl}
\script {
	switch (arg[0]) {
	case "index":
		if (arg[1] == 1) {
			set("label", "Search");
			set("FGColor", "white");
			canSearchP = 1;
		} else {
			set("label", "No Search");
			set("FGColor", "grey60");
			canSearchP = 0;
		}
		render();
		return;
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		if (canSearchP) 
			return "Keyword search mode indicator (now on)";
		else 
			return "Keyword search mode indicator (now off)";
	break;
	}
	usual();
}
\label {No Search}
\maxWidth {79}
\BDColor {grey45}
\BGColor {grey45}
\FGColor {grey60}
\
\class {txtEdit}
\name {www.doc.ctrl.tf}
\parent {www.doc.ctrl}
\script {
	switch (arg[0]) {
	case "keyPress":
		if (canSearchP == 0) {
			bell();
			www.mesg.tf("warn", 
				"Document is not index; no searching allowed."); 
		} else {
			c = key();
			if (c == '\r') {
				if (saveMouse) {
					/* restore mouse position */
					setMouse(saveMousePos[0], 
						saveMousePos[1]);
					saveMouse = 0;
				}
				www("search", currentLine());
				insert(c);
				if (cursorRow() != 0) {
					/* a kludgy safe guard to simulate
					 * carriage-return then ctrl-p 
					 */
					insert("\r\16"); 
				}
			} else {
				insert(c);
			}
		}
		return;
	break;
	case "index":
		if (arg[1] == 1) {
			canSearchP = 1;
		} else {
			canSearchP = 0;
		}
		return;
	break;
	case "show":
		set("content", arg[1]);
		render();
		return;
	break;
	case "focus":
		/* move cursor to www.doc.ctrl.tf */
		saveMousePos = mouse();
		saveMouse = 1;
		winPos = windowPosition();
		setMouse(winPos[0] + 18, winPos[1] + 18);
		send(self(), "enter");
		send(self(), "keyPress"); /* redirect keypresses */
		return;
	break;
	case "enter":
		www.mesg.tf("suggest", self(), arg[0]);
/*		if (canSearchP == 0) set("cursor", 0);
		return;
*/
	break;
	case "leave":
		/* cancel mouse warp to avoid confusion */
		if (saveMouse) saveMouse = 0;
		www.mesg.tf("suggest", self(), arg[0]);
	break;
	case "hint":
		if (canSearchP) 
			return "Keyword search entry field (valid, can enter a keyword now)";
		else
			return "Keyword search entry field (invalid)";
	break;
	case "init":
		canSearchP = 0;
		saveMouse = 0;
	break;
	}
	usual();
}
\BDColor {grey20}
\BGColor {grey45}
\FGColor {white}
\CRColor {yellow}
\font {any}
\
\class {menu}
\name {www.doc.ctrl.pref}
\parent {www.doc.ctrl}
\script {
	switch (arg[0]) {
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Preference settings.";
	break;
	case "colorsBGFGBD":
		/* Need a better relative refencing scheme... */
		send(send(get("parent"), "whichPageP"), 
			arg[0], arg[1], arg[2], arg[3]);
		return;
	break;
	case "randomColors ;-)":
	case "reverseVideo":
		/* Need a better relative refencing scheme... */
		send(send(get("parent"), "whichPageP"), arg[0]);
		return;
	break;
	}
	usual();
}
\label {c}
\menuConfig {
.{LemonChiffon1}	{send(get("name"), "colorsBGFGBD", "LemonChiffon1", "black", "grey75");}
.{LemonChiffon2}	{send(get("name"), "colorsBGFGBD", "LemonChiffon2", "black", "grey75");}
.{Grey}			{send(get("name"), "colorsBGFGBD", "grey30", "white", "grey75");}
}
\maxWidth {20}
\BDColor {grey75}
\BGColor {grey45}
\FGColor {white}
\CRColor {SlateGray1}
\
\class {XBMButton}
\name {www.doc.ctrl.ol}
\parent {www.doc.ctrl}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		if (state == 1) state = 0;
		else state = 1;
/*		send(send(get("parent"), "whichPageP"), "outliner", state);*/
		send(parent(), "outliner", state);
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click to toggle outliner facility.";
	break;
	case "init":
		state = 0;
	break;
	}
	usual();
}
\label {#define ol_width 16
#define ol_height 16
static char ol_bits[] = {
   0x00, 0x00, 0xfe, 0x00, 0x00, 0x00, 0xf8, 0x03, 0x00, 0x00, 0xf8, 0x07,
   0x00, 0x00, 0xe0, 0x03, 0x00, 0x00, 0xf8, 0x0f, 0x00, 0x00, 0xfe, 0x01,
   0x00, 0x00, 0xf8, 0x01, 0x00, 0x00, 0x00, 0x00};
}
\maxWidth {16}
\BDColor {grey20}
\BGColor {grey45}
\FGColor {white}
\
\class {XBMButton}
\name {www.doc.ctrl.prt}
\parent {www.doc.ctrl}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send(send(get("parent"), "whichPageP"), "print");
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click to print a hardcopy of the current document.";
	break;
	}
	usual();
}
\label {#define prt_width 16
#define prt_height 16
static char prt_bits[] = {
   0x00, 0x00, 0xf8, 0x03, 0x88, 0x06, 0xf8, 0x0e, 0x88, 0x08, 0xf8, 0x0f,
   0x08, 0x08, 0xf8, 0x0f, 0x08, 0x08, 0xfc, 0x1f, 0x02, 0x20, 0x02, 0x60,
   0x1a, 0x60, 0x02, 0x20, 0xfe, 0x3f, 0x00, 0x00};
}
\maxWidth {16}
\BDColor {grey20}
\BGColor {grey45}
\FGColor {white}
\
\class {XBMButton}
\name {www.doc.ctrl.reload}
\parent {www.doc.ctrl}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send(send(get("parent"), "whichPageP"), "reload");
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click to reload document.";
	break;
	}
	usual();
}
\label {#define reload_width 16
#define reload_height 16
static char reload_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0xca, 0x00, 0x26, 0x01, 0xe2, 0x01, 0x22, 0x00,
   0xc2, 0x00, 0x00, 0x00, 0x00, 0x20, 0x02, 0x20, 0x12, 0x33, 0xaa, 0x2a,
   0xaa, 0x2a, 0xaa, 0x2a, 0x12, 0x35, 0x00, 0x00};
}
\maxWidth {16}
\BDColor {grey20}
\BGColor {grey45}
\FGColor {white}
\
\class {XBMButton}
\name {www.doc.ctrl.src}
\parent {www.doc.ctrl}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send(send(get("parent"), "whichPageP"), "showSrc");
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click to see the source of the current document.";
	break;
	}
	usual();
}
\label {#define src_width 16
#define src_height 16
static char src_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xcc, 0x31, 0x52, 0x0a, 0x42, 0x0a,
   0x42, 0x0a, 0xc4, 0x0b, 0x48, 0x09, 0x50, 0x09, 0x50, 0x09, 0x52, 0x0a,
   0x4c, 0x32, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
}
\maxWidth {16}
\BDColor {grey20}
\BGColor {grey45}
\FGColor {white}
\
\class {XBMButton}
\name {www.doc.ctrl.out2File}
\parent {www.doc.ctrl}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send(send(get("parent"), "whichPageP"), "output2File");
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click to save document to a file.";
	break;
	}
	usual();
}
\label {#define out2File_width 16
#define out2File_height 16
static char out2File_bits[] = {
   0x00, 0x00, 0x3c, 0x00, 0x5c, 0x00, 0x9c, 0x06, 0xfc, 0x08, 0xfc, 0x08,
   0xfc, 0x3e, 0xfc, 0x1c, 0x00, 0x08, 0x00, 0x00, 0xae, 0x38, 0xa2, 0x08,
   0xae, 0x18, 0xa2, 0x08, 0xa2, 0x3b, 0x00, 0x00};
}
\maxWidth {16}
\BDColor {grey20}
\BGColor {grey45}
\FGColor {white}
\
\class {XBMButton}
\name {www.doc.ctrl.tear}
\parent {www.doc.ctrl}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		if (isTorn == 1) {
/*			send(send(get("parent"), "whichPageP"), "quit");*/
			send(get("parent"), "quit");
		} else {
/*			send(send(get("parent"), "whichPageP"), "tear");*/
			send(get("parent"), "tear");
		}
	break;
	case "torn":
		set("label", get("content"));
		if (get("window")) {
			cycleColors(0);
			render();
		}
		isTorn = 1;
		return;
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		if (isTorn == 1) {
			return "Click to dismiss the page.";
		} else {
			return "Click to tear out a clone page.";
		}
	break;
	}
	usual();
}
\content {#define destroy_width 16
#define destroy_height 16
static char destroy_bits[] = {
   0xe0, 0x04, 0x00, 0x07, 0x00, 0x38, 0xf0, 0x3f, 0x10, 0x20, 0x50, 0x35,
   0x50, 0x35, 0x50, 0x35, 0x50, 0x35, 0x50, 0x35, 0x50, 0x35, 0x50, 0x35,
   0x58, 0x35, 0x14, 0x20, 0xe6, 0x1f, 0x00, 0x00};
}
\label {#define tear_width 16
#define tear_height 16
static char tear_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0xfc, 0x0f, 0x0e, 0x0c, 0xfc, 0x0f, 0x0a, 0x0c,
   0xfc, 0x1f, 0x1a, 0x18, 0xf4, 0x3f, 0x3a, 0x70, 0xf4, 0xff, 0xea, 0x0f,
   0x54, 0x15, 0xaa, 0x0a, 0x54, 0x15, 0x00, 0x00};
}
\maxWidth {16}
\BDColor {grey20}
\BGColor {grey45}
\FGColor {white}
\
\class {hpane}
\name {www.mesg}
\parent {www}
\children {www.mesg.label www.mesg.tf www.ahelp.label}
\maxHeight {32}
\BDColor {55 55 55}
\BGColor {25 25 25}
\FGColor {99 99 99}
\
\class {txtLabel}
\name {www.mesg.label}
\parent {www.mesg}
\label {Message:}
\maxWidth {80}
\BDColor {grey20}
\BGColor {grey45}
\FGColor {white}
\paneConfig {eastToWest}
\font {any}
\
\class {txtDisp}
\name {www.mesg.tf}
\parent {www.mesg}
\script {
	switch (arg[0]) {
	case "suggest":
		if (suggest == 0) return;
		if (get("visible")) {
			if (arg[2] == "leave") {
				set("content", "");
				render();
			} else {
				hint = send(arg[1], "hint");
				if (isBlank(hint) == 0) {
					set("content", hint);
					if (get("window")) {
						set("FGColor", "100 90 70");
						render();
					}
				}
			}
			isCleared = 0;
		}
		return;
	break;
	case "show":
		set("content", arg[1]);
		if (get("window")) {
			set("FGColor", "100 90 70");
			render();
			isCleared = 0;
		}
		return;
	break;
	case "alert":
		if (get("render")) {
			set("BGColor", "red");
			set("content", " ");
			render();
			set("BGColor", "grey45");
			set("FGColor", "90 90 90");
			set("content", arg[1]);
			render();
/*			after(5000, "www.mesg.tf", "clear");*/
			isCleared = 0;
		}
		return;
	break;
	case "warn":
		if (get("render")) {
			set("BGColor", "yellow");
			set("content", " ");
			render();
			set("BGColor", "grey45");
			set("FGColor", "90 90 90");
			set("content", arg[1]);
			render();
/*			after(5000, "www.mesg.tf", "clear");*/
		}
		isCleared = 0;
		return;
	break;
	case "flash":
		if (get("render")) {
			set("BGColor", "green");
			set("content", " ");
			render();
			set("BGColor", "grey45");
			set("FGColor", "90 90 90");
			set("content", arg[1]);
			render();
/*			after(5000, "www.mesg.tf", "clear");*/
			isCleared = 0;
		}
		return;
	break;
	case "clear":
		if (isCleared == 0) {
			set("content", "");
			render();
			isCleared = 1;
		}
		return;
	break;
	case "enter":
		set("cursor", 0);
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "The active hints/message text field....";
	break;
	case "keyPress":
		return;
	break;
	case "turnOffSuggest":
		suggest = 0;
		www.mesg.tf("warn", "Active help is now off.");
		return;
	break;
	case "toggleSuggest":
		if (suggest == 1) {
			suggest = 0;
			www.mesg.tf("warn", "Active help is now off.");
		} else {
			suggest = 1;
			www.mesg.tf("warn", "Active help is now on.");
		}
		return;
	break;
	case "init":
/*		after(50000, "www.mesg.tf", "clear");*/
		suggest = 0;
	break;
	}
	usual();
}
\BDColor {grey20}
\BGColor {grey45}
\FGColor {100 80 60}
\verbatim {1}
\font {fixed}
\
\class {XBMButton}
\name {www.ahelp.label}
\parent {www.mesg}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		xx = get("label");
		set("label", get("content"));
		set("content", xx);
		render();
		www.mesg.tf("toggleSuggest");
		return;
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click to toggle active helper.";
	break;
	}
	usual();
}
\content {#define bubble1_width 16
#define bubble1_height 16
static char bubble1_bits[] = {
   0x00, 0x00, 0xe0, 0x07, 0xf8, 0x1f, 0xfc, 0x3f, 0x8c, 0x36, 0xae, 0x74,
   0xae, 0x74, 0xae, 0x72, 0xae, 0x72, 0xac, 0x36, 0x8c, 0x36, 0xf8, 0x1f,
   0xe0, 0x07, 0x78, 0x00, 0x06, 0x00, 0x00, 0x00};
}
\label {#define bubble0_width 16
#define bubble0_height 16
static char bubble0_bits[] = {
   0x00, 0x00, 0xe0, 0x07, 0xf8, 0x1f, 0xfc, 0x3f, 0x8c, 0x24, 0xae, 0x76,
   0xae, 0x64, 0xae, 0x76, 0xae, 0x76, 0xac, 0x36, 0x8c, 0x36, 0xf8, 0x1f,
   0xe0, 0x07, 0x78, 0x00, 0x06, 0x00, 0x00, 0x00};
}
\maxWidth {16}
\BDColor {grey20}
\BGColor {grey45}
\FGColor {white}
\
\class {XBMButton}
\name {www.wais.label}
\parent {www.mesg}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		wais("render");
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click to use WAIS-Search.";
	break;
	}
	usual();
}
\label {#define wais_width 16
#define wais_height 16
static char wais_bits[] = {
   0x00, 0x00, 0x82, 0x18, 0x82, 0x24, 0x92, 0x24, 0x92, 0x3c, 0x92, 0x24,
   0x6c, 0x24, 0x00, 0x81, 0x00, 0x00, 0x38, 0x3c, 0x10, 0x02, 0x10, 0x1c,
   0x10, 0x20, 0x10, 0x20, 0x38, 0x1e, 0x80, 0x80};

}
\maxWidth {16}
\BDColor {grey20}
\BGColor {grey45}
\FGColor {white}
\
\class {hpane}
\name {www.url}
\parent {www}
\children {www.url.label www.url.tf www.url.setURL}
\maxHeight {32}
\BDColor {55 55 55}
\FGColor {99 99 99}
\BGColor {grey45}
\
\class {txtLabel}
\name {www.url.label}
\parent {www.url}
\label {URL:}
\maxWidth {80}
\BDColor {grey20}
\BGColor {grey45}
\FGColor {white}
\font {any}
\paneConfig {eastToWest}
\
\class {txtEdit}
\name {www.url.tf}
\parent {www.url}
\script {
	switch (arg[0]) {
	case "keyPress":
		c = key();
		if (c == '\r') {
			www("show", trimEdge(currentLine()));
			render();
		} else {
			insert(c);
		}
		return;
	break;
	case "getURLFromClipBuffer":
		www("show", trimEdge(getSelection()));
		return;
	break;
	case "appendURLToHome":
		www.mesg.tf("alert", 
			    "Sorry, can't yet append to home page.");
		return;
	break;
	case "show":
		set("content", trimEdge(arg[1]));
		render();
		return;
	break;
	case "enter":
	case "leave":
		usual();
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "It's the current document address.";
	break;
	}
	usual();
}
\BDColor {grey20}
\BGColor {grey45}
\FGColor {white}
\CRColor {yellow}
\font {fixed}
\
\class {XBMButton}
\name {www.url.setURL}
\parent {www.url}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		www.url.tf("getURLFromClipBuffer");
	break;
	case "enter":
	case "leave":
		www.mesg.tf("suggest", get("name"), arg[0]);
		return;
	break;
	case "hint":
		return "Click to read URL from X selection buffer.";
	break;
	}
	usual();
}
\label {#define cut_width 16
#define cut_height 16
static char cut_bits[] = {
   0x00, 0x00, 0x04, 0x00, 0x06, 0x00, 0xff, 0x03, 0x06, 0x0c, 0x04, 0x10,
   0x00, 0x00, 0x38, 0x00, 0x44, 0x78, 0x44, 0xfe, 0x78, 0x0f, 0xc0, 0x00,
   0x78, 0x0f, 0x44, 0xfe, 0x44, 0x78, 0x38, 0x00};
}
\maxWidth {16}
\BDColor {grey20}
\BGColor {grey45}
\FGColor {white}
\
