\name	{shell}
\class	{vpane}
\parent	{}
\lock {1}
\width {500}
\height {200}
\script	{
	switch (arg[0]) {
	case "targetSet":
		shell.obj.entry("show");
		return;
	break;
	case "raise":
		raise();
		return;
	break;
	}
	usual();
}
\children {shell.top shell.obj shell.in shell.out shell.mesg}
\
\name	{shell.top}
\class	{hpane}
\parent	{shell}
\lock {1}
\children {shell.top.tools shell.top.ops shell.top.attrs shell.top.title shell.top.dismiss}
\maxHeight {25}
\
\name	{shell.top.tools}
\class	{menu}
\parent	{shell.top}
\label {Tools}
\lock {1}
\script	{
	switch (arg[0]) {
	case "tool":
		tool(arg[1]);
		shell.mesg("show", concatenate("current tool: ", arg[1]));
	break;
	}
	usual();
}
\menuConfig {
.	{Action}		{shell.top.tools("tool", "action");}
.	{Target}		{shell.top.tools("tool", "target");}
.	{Move}			{shell.top.tools("tool", "move");}
.	{Resize}		{shell.top.tools("tool", "resize");}
.	{Reparent}		{shell.top.tools("tool", "reparent");}
}
\BGColor {grey25}
\FGColor {white}
\BDColor {grey}
\font {normal}
\maxWidth {70}
\
\name	{shell.top.ops}
\class	{menu}
\parent	{shell.top}
\label {Operations}
\lock {1}
\script	{
	switch (arg[0]) {
	case "cloneTarget":
		new = tweak(target(), "clone(1);");
		print("newobj=", new, "\n");
		tweak(new, "set(\"parent\", \"\");");
		send(new, "info");
		send(new, "visible", 1);
		return;
	break;
	}
	usual();
}
\menuConfig {
.	{Target parent}		{target(tweak(target(), "get(\"parent\");"));}
.	{Clone target}		{shell.top.tools("cloneTarget");}
.	{Info target}		{tweak(target(), "info();");}
.	{Save target}		{tweak(target(), "save();");}
.	{}
.	{Create object}		{op_create("visible", 1);}
.	{}
.	{Vicon}			{vicon("visible", 1);}
.	{save dump}		{saveAs("foo");}
.	{save command text}	{shell.in.tf("saveText");}
.	{load command text}	{shell.in.tf("loadText");}
.	{Quit}			{quit();}
}
\BGColor {grey25}
\FGColor {white}
\BDColor {grey}
\font {normal}
\maxWidth {100}
\
\name	{shell.top.attrs}
\class	{menu}
\parent	{shell.top}
\label {Attributes}
\lock {1}
\menuConfig {
.	{content}		{ed_TE("edit", target(), "content");}
.	{script}		{ed_TE("edit", target(), "script");}
.	{label}			{ed_label("edit", target());}
.	{BDColor}		{ed_BDColor("visible", 1);}
.	{BGColor}		{ed_BGColor("visible", 1);}
.	{FGColor}		{ed_FGColor("visible", 1);}
.	{CRColor}		{ed_CRColor("visible", 1);}
.	{content}		{ed_content("visible", 1);}
.	{menuConfig}		{ed_menuConfig("visible", 1);}
.	{geometry}		{ed_geometry("visible", 1);}
.	{script}		{ed_script("visible", 1);}
}
\BGColor {grey25}
\FGColor {white}
\BDColor {grey}
\font {normal}
\maxWidth {100}
\
\name	{shell.top.title}
\class	{txtLabel}
\parent	{shell.top}
\lock {1}
\label {Viola Interpreter Shell}
\BGColor {grey45}
\FGColor {black}
\BDColor {grey}
\
\name	{shell.top.dismiss}
\class	{txtButton}
\parent	{shell.top}
\lock {1}
\script	{
	switch (arg[0]) {
	case "buttonRelease":
		tweak("shell", "quit();");
	break;
	}
	usual();
}
\maxWidth {100}
\label {Dismiss}
\BGColor {grey25}
\FGColor {white}
\BDColor {grey}
\
\name	{shell.top}
\class	{hpane}
\parent	{shell}
\lock {1}
\children {shell.top.tools shell.top.ops shell.top.attrs shell.top.title shell.top.dismiss}
\maxHeight {25}
\
\name	{shell.top.tools}
\class	{menu}
\parent	{shell.top}
\label {Tools}
\lock {1}
\script	{
	switch (arg[0]) {
	case "tool":
		tool(arg[1]);
		shell.mesg("show", concatenate("current tool: ", arg[1]));
	break;
	}
	usual();
}
\menuConfig {
.	{Action}		{shell.top.tools("tool", "action");}
.	{Target}		{shell.top.tools("tool", "target");}
.	{Move}			{shell.top.tools("tool", "move");}
.	{Resize}		{shell.top.tools("tool", "resize");}
.	{Reparent}		{shell.top.tools("tool", "reparent");}
}
\BGColor {grey25}
\FGColor {white}
\BDColor {grey}
\font {normal}
\maxWidth {70}
\
\name	{shell.top.ops}
\class	{menu}
\parent	{shell.top}
\label {Operations}
\lock {1}
\script	{
	switch (arg[0]) {
	case "cloneTarget":
		new = tweak(target(), "clone(1);");
		print("newobj=", new, "\n");
		tweak(new, "set(\"parent\", \"\");");
		send(new, "info");
		send(new, "visible", 1);
		return;
	break;
	}
	usual();
}
\menuConfig {
.	{Target parent}		{target(tweak(target(), "get(\"parent\");"));}
.	{Clone target}		{shell.top.tools("cloneTarget");}
.	{Info target}		{tweak(target(), "info();");}
.	{Save target}		{tweak(target(), "save();");}
.	{}
.	{Create object}		{op_create("visible", 1);}
.	{}
.	{Vicon}			{vicon("visible", 1);}
.	{save dump}		{saveAs("foo");}
.	{save command text}	{shell.in.tf("saveText");}
.	{load command text}	{shell.in.tf("loadText");}
.	{Quit}			{quit();}
}
\BGColor {grey25}
\FGColor {white}
\BDColor {grey}
\font {normal}
\maxWidth {100}
\
\name	{shell.top.attrs}
\class	{menu}
\parent	{shell.top}
\label {Attributes}
\lock {1}
\menuConfig {
.	{content}		{ed_TE("edit", target(), "content");}
.	{script}		{ed_TE("edit", target(), "script");}
.	{label}			{ed_label("edit", target());}
.	{BDColor}		{ed_BDColor("visible", 1);}
.	{BGColor}		{ed_BGColor("visible", 1);}
.	{FGColor}		{ed_FGColor("visible", 1);}
.	{content}		{ed_content("visible", 1);}
.	{menuConfig}		{ed_menuConfig("visible", 1);}
.	{geometry}		{ed_geometry("visible", 1);}
.	{script}		{ed_script("visible", 1);}
}
\BGColor {grey25}
\FGColor {white}
\BDColor {grey}
\font {normal}
\maxWidth {100}
\
\name	{shell.top.title}
\class	{txtLabel}
\parent	{shell.top}
\lock {1}
\label {Viola Interpreter Shell}
\BGColor {grey45}
\FGColor {black}
\BDColor {grey}
\
\name	{shell.top.dismiss}
\class	{txtButton}
\parent	{shell.top}
\lock {1}
\script	{
	switch (arg[0]) {
	case "buttonRelease":
		tweak("shell", "quit();");
	break;
	}
	usual();
}
\maxWidth {100}
\label {Dismiss}
\BGColor {grey25}
\FGColor {white}
\BDColor {grey}
\
\name	{shell.obj}
\class	{hpane}
\parent	{shell}
\children {shell.obj.label shell.obj.entry}
\maxHeight {18}
\lock {1}
\
\name	{shell.obj.label}
\class	{txtLabel}
\parent	{shell.obj}
\label {Object:}
\maxWidth {80}
\lock {1}
\BGColor {grey25}
\FGColor {white}
\BDColor {grey}
\
\name	{shell.obj.entry}
\class	{txtEdit}
\parent	{shell.obj}
\lock {1}
\script	{
	switch (arg[0]) {
	case "show":
		set("content", target());
		if (get("window")) render();
		return;
	break;
	case "keyPress":
		c = key();
		if (c == '\r') {
			if (isBlank(target())) target("res");
			target(currentLine());
			shell.obj.entry("show");
			return;
		} else {
			insert(c);
			return;
		}
	break;
	case "init":
		set("content", target());
	break;
	}
	usual();
}
\BGColor {grey25}
\FGColor {white}
\BDColor {grey}
\
\name	{shell.in}
\class	{hpane}
\parent	{shell}
\lock {1}
\children {shell.in.sb shell.in.tf}
\
\name	{shell.in.sb}
\class	{slider}
\parent	{shell.in}
\lock {1}
\BDColor {grey99}
\BGColor {grey45}
\FGColor {grey70}
\shownNotify {shell.in.tf}
\maxWidth {15}
\
\name	{shell.in.tf}
\parent	{shell.in}
\class	{txtEdit}
\lock {1}
\script	{
	switch (arg[0]) {
	case "buttonPress":
		print("DUMPING CONTENT\n {", get("content"), "}\n");
	break;
	case "keyPress":
		c = key();
		if (c == '\r') {
			print("issue command:", currentLine(), "\n");
			if (isBlank(target())) target("res");
			ret = tweak(target(), currentLine());
			shell.obj.entry("show");
			insert('\r');
			shell.out.tf("insert", ret);
			return;
		} else {
			insert(c);
			return;
		}
	break;
	case "saveText":
		saveFile(".shellCmds", get("content"));
		return;
	break;
	case "loadText":
		path = accessible(".shellCmds");
		if (path != "") {
			set("content", loadFile(path));
			render();
		}
		return;
	break;
	case "init":
		path = accessible(".shellCmds");
		if (path != "") {
			set("content", loadFile(path));
		}
		if (isBlank(target())) target("res");
	break;
	case "expose":
		usual();
		print("DUMPING CONTENT\n {", get("content"), "}\n");
		return;
	break;
	}
	usual();
}
\shownDepend {shell.in.sb}
\BGColor {grey40}
\FGColor {grey90}
\BDColor {grey45}
\CRColor {white}
\verbatim {1}
\font {fixed}
\
\name	{shell.out}
\class	{hpane}
\parent	{shell}
\lock {1}
\children {shell.out.sb shell.out.tf}
\
\name	{shell.out.sb}
\class	{slider}
\parent	{shell.out}
\lock {1}
\BDColor {grey99}
\BGColor {grey45}
\FGColor {grey70}
\shownNotify {shell.out.tf}
\maxWidth {15}
\
\name	{shell.out.tf}
\parent	{shell.out}
\class	{txtEdit}
\lock {1}
\script	{
	switch (arg[0]) {
	case "insert":
		print("ret = ", arg[1], "\n");
		insert(arg[1]);
		return;
	break;
	}
	usual();
}
\shownDepend {shell.out.sb}
\BGColor {grey40}
\FGColor {grey90}
\BDColor {grey45}
\verbatim {1}
\font {fixed}
\
\name	{shell.mesg}
\class	{txtDisp}
\parent	{shell}
\lock {1}
\script	{
	if (arg[0] == "show") {
		set("content", arg[1]);
		render();
		return;
	}
	usual();
}
\content {Messages}
\font {usual_small}
\maxHeight {30}
\BGColor {grey45}
\FGColor {white}
\BDColor {grey}
\
