\class {XBM}
\security {1}
\name {HMML_bulletItem}
\script {
	switch (arg[0]) {
	case "D":
		w = width(); /* width before label */
		set("label", get("content"));
		set("width", w);
		return -1;
	break;
	case 'R':
		/* arg[1]	y
		 * arg[2]	width
		 */
		clearWindow();
		set("y", arg[1]);
		set("width", arg[2]);
		vspan = building_vspan();
		set("height", vspan);
		render();
		return vspan;
	break;
	case "noBullet":
		w = width();
		set("label", "");
		clearWindow();
		set("width", w);
		return;
	break;
	case "config":
		return;
	break;
	case "searchAnchor":
		if (get("content2") == arg[1]) return self();
		n = countChildren();
		if (n > 0) {
			for (i = 0; i < n; i++) {
				anchor = send(nthChild(i), 
						"searchAnchor", arg[1]);
				if (anchor != "") return anchor;
			}
		}
		return "";
	break;
	case "gotoAnchor":
		if (get("content2") == arg[1]) return y();
		n = countChildren();
		if (n > 0) {
			for (i = 0; i < n; i++) {
				offset = send(nthChild(i), 
						"gotoAnchor", arg[1]);
				if (offset > 0) return offset + y();
			}
		}
		return 0;
	break;
	case "findTop":
		return send(parent(), "findTop");
	break;
	}
	usual();
}
\content {#define bullet_width 8
#define bullet_height 16
static char bullet_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x38, 0x7c, 0xbe, 0x7e,
   0xba, 0x54, 0x28, 0x00};
}
\FGColor {black}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\
