\class {field}
\security {1}
\name {HMML_listNumbered}
\script {
	switch (arg[0]) {
	case "D":
		h = SGMLBuildDoc_span();
		set("height", h);

		n = countChildren();
		if (n > 0) {
			for (i = 0; i < n; i++) {
				itemN = itemN + 1;
				send(nthChild(i), "itemN", itemN);
			}
		}
		return h;
	break;
	case 'L':
		return 'O';
	break;
	case "expose":
		send(parent(), "noBullet");
	break;
	case "noBullet":
		send(parent(), "noBullet");
		return;
	break;
	case 'R':
		/* arg[1]	y
		 * arg[2]	width
		 */
		style = SGMLGetStyle("HMML", "SECTION");
		vspan = style[0];
		set("x", style[2]);
		set("y", arg[1] + vspan);
		set("width", arg[2] - x() - style[3]);

		n = countChildren();
		if (n) {
			xx = width();
			for (i = 0; i < n; i++) {
				vspan = vspan 
					+ send(nthChild(i), 'R', vspan, xx);
			}
		}
		set("height", vspan);
		vspan += style[1];
		return vspan;
	break;
	case "AA":
		switch (arg[1]) {
		case "ID":
			id = arg[2];
		break;
		case "COMPACT":
			compact = 1;
		break;
		}
		return;
	break;
	case "AI":
		return;
	break;
	case "compact":
		return compact;
	break;
	case "searchAnchor":
		if (id == arg[1]) return self();
		n = countChildren();
		if (n > 0) {
			for (i = 0; i < n; i++) {
				anchor = send(nthChild(i), 
						"searchAnchor", arg[1]);
				if (anchor != "") return anchor;
			}
		}
		return "";
	break;
	case "gotoAnchor":
		if (id == arg[1]) return y();
		n = countChildren();
		if (n > 0) {
			for (i = 0; i < n; i++) {
				offset = send(nthChild(i), 
						"gotoAnchor", arg[1]);
				if (offset > 0) return offset + y();
			}
		}
		return 0;
	break;
	case "findTop":
		return send(parent(), "findTop");
	break;
	}
	usual();
}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\
