\class {field}
\security {1}
\name {HTML__txtBox_caution}
\children {HTML__txtBox_caution.txt HTML__txtBox_caution.icon}
\script {
	switch (arg[0]) {
	case "make":
		/* arg[1]	parent
		 * arg[2]	txt
		 * arg[3]	width to use
		 */
		set("parent", arg[1]);
		set("width", arg[3]);
		h = send(nthChild(0), "make", arg[2], arg[3]) + 3;
		set("height", h);
		eventMask("+pointerMotion +leaveWindow");
		return h;
	break;
	case 'R': /* resize */
		set("width", arg[1]);
		h = send(nthChild(0), 'R', arg[1]) + 3;
		set("height", h);
		return h;
	break;
	case "findTop":
		return send(parent(), "findTop");
	break;
	case "clone":
		return clone(cloneID());
	break;
	case "init":
		usual();
		color = getResource("Viola.background_doc");
		if (color) set("BGColor", color);
		color = getResource("Viola.foreground_doc");
		if (color) set("FGColor", color);
		color = getResource("Viola.borderColor_doc");
		if (color) set("BDColor", color);
		return;
	break;
	}
	usual();
}
\width {100}
\height {8}
\BDColor {LemonChiffon1}
\BGColor {lemonChiffon1}
\
\class {txtDisp}
\security {1}
\parent {HTML__txtBox_caution}
\name {HTML__txtBox_caution.txt}
\script {
	switch (arg[0]) {
	case "make":
		/* arg[1]	txt
		 * arg[2]	width to use
		 */
		txt = arg[1];
		set("width", arg[2] - 50);
		eventMask("+pointerMotion +leaveWindow");
		set("content", txt);
		h = building_vspan();
		if (h < 32) h = 32;
		set("height", h);
		return h;
	break;
	case 'R': /* resize */
		clearWindow();
		set("width", arg[1] - 50);
		set("content", txt);
		h = building_vspan();
		if (h < 32) h = 32;
		set("height", h);
		render();
		return h;
	break;
	case "mouseMove":
		hint = test4();
		/*processMouseMove();*/
		if (prevHint != hint) {
			if (isBlank(hint)) www.mesg.tf("clear");
			else www.mesg.tf("show", hint);
		}
		prevHint = hint;
		return;
	break;
	case "leave":
		prevHint = 0;
		www.mesg.tf("clear");
		return;
	break;
	case "findTop":
		return send(parent(), "findTop");
	break;
	case "init":
		usual();
		color = getResource("Viola.background_doc");
		if (color) set("BGColor", color);
		color = getResource("Viola.foreground_doc");
		if (color) set("FGColor", color);
		color = getResource("Viola.borderColor_doc");
		if (color) set("BDColor", color);
		return;
	break;
	}
	return code_HTML_txt(arg);
}
\x {50}
\width {10}
\height {10}
\BDColor {LemonChiffon1}
\BGColor {lemonChiffon1}
\FGColor {black}
\font {normal}
\format {1}
\
\class {XBM}
\security {1}
\parent {HTML__txtBox_caution}
\name {HTML__txtBox_caution.icon}
\script {
	switch (arg[0]) {
	case "init":
		usual();
		color = getResource("Viola.background_doc");
		if (color) set("BGColor", color);
		color = getResource("Viola.borderColor_doc");
		if (color) set("BDColor", color);
		return;
	break;
	}
	usual();
}
\label {#define caution_width 34
#define caution_height 31
static char caution_bits[] = {
 0x00,0x00,0x00,0x00,0xfc,0x00,0x00,0x00,0x00,0xfc,0xf8,0xff,0xff,0x7f,0xfc,
 0xf8,0xff,0xff,0x7f,0xfc,0xfc,0xff,0xff,0xff,0xfc,0xfc,0xff,0xfc,0xff,0xfc,
 0xf8,0x7f,0xf8,0x7f,0xfc,0xf8,0x7f,0xf8,0x7f,0xfc,0xf0,0x7f,0xf8,0x3f,0xfc,
 0xf0,0x7f,0xf8,0x3f,0xfc,0xe0,0x7f,0xf8,0x1f,0xfc,0xe0,0x7f,0xf8,0x1f,0xfc,
 0xc0,0x7f,0xf8,0x0f,0xfc,0xc0,0x7f,0xf8,0x0f,0xfc,0x80,0xff,0xfc,0x07,0xfc,
 0x00,0xff,0xfc,0x03,0xfc,0x00,0xff,0xfc,0x03,0xfc,0x00,0xfe,0xfc,0x01,0xfc,
 0x00,0xfe,0xff,0x01,0xfc,0x00,0xfc,0xff,0x00,0xfc,0x00,0xfc,0xfc,0x00,0xfc,
 0x00,0x78,0x78,0x00,0xfc,0x00,0xf8,0x7c,0x00,0xfc,0x00,0xf0,0x3f,0x00,0xfc,
 0x00,0xe0,0x1f,0x00,0xfc,0x00,0xe0,0x1f,0x00,0xfc,0x00,0xc0,0x0f,0x00,0xfc,
 0x00,0xc0,0x0f,0x00,0xfc,0x00,0x80,0x07,0x00,0xfc,0x00,0x00,0x00,0x00,0xfc,
 0x00,0x00,0x00,0x00,0xfc};
}
\x {5}
\width {34}
\height {32}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\FGColor {darkOrange}
\
