\class {txtDisp}
\security {1}
\name {HMML_pre}
\script {
	switch (arg[0]) {
	case 'D':
		tagPtr = STG_tagPtr("PRE");
		if (tagPtr) {
			i = STG_attr(tagPtr, "BGColor");
			if (i) set("BGColor", i);
			i = STG_attr(tagPtr, "FGColor");
			if (i) set("FGColor", i);
			i = STG_attr(tagPtr, "BDColor");
			if (i) set("BDColor", i);
		}

		set("content", get("label"));
		return (building_vspan() + 2);
	break;
	case 'R':
		/* arg[1]	y
		 * arg[2]	width
		 */
		clearWindow();
		style = SGMLGetStyle("HMML", "PRE");
		vspan = style[0];
		set("y", arg[1] + vspan);
		set("x", style[2]);
		set("width", arg[2] - x() - style[3]);
		set("content", get("content"));
		vspan = vspan + set("height", building_vspan()) + style[1];
		render();
		return vspan;
	break;
	case 'r':
		style = SGMLGetStyle("HMML", "PRE");
		vspan = style[0];
		set("width", width() - style[3]);
		set("content", get("content"));
		vspan = vspan + set("height", building_vspan()) + style[1];
		return vspan;
	break;
	case "config":
		return;
	break;
	case "expose":
		switch (nthWord(get("content"), 3)) {
		case "finger":
			set("children", 
				send("invokeFinger", 
					"new", self(), 
					parent(), 
					x() + width(), y()));
		break;
		case "telnet":
			set("children", 
				send("invokeTelnet", 
					"new", self(), 
					parent(), 
					x() + width(), y()));
		break;
		}
	break;
	case "heightP":
		return get("height");
	break;
	case "widthP":
		return get("width");
	break;
	case "gotoAnchor":
		return 0;
	break;
	}
	usual();
}
\width {100}
\height {30}
\font {fixed}
\BGColor {LemonChiffon2}
\BDColor {black}
\FGColor {black}
\
