/*
# ViolaWWW HTML Processing/Rendering #  inline?
# Configuration File		     #  | notfy-on-creation?	top
######################################  | | ?flushBySelf?	| bttm
#					| | | on-sub?		| | left
# Tag Name	Processing Obj		| | | | hpane? 	        | | | right
*/

char *HTML_stylesheet_str = "\
P 		HTML_txt 		0 0 0 1 0		3 3 3 3\n\
A 		HTML_txtAnchor	 	1 0 0 0 0		0 0 0 0\n\
AUTHOR 		HTML_author	 	0 0 0 0 0		0 0 0 0\n\
B 		HTML_txtBold	 	1 0 0 0 0		0 0 0 0\n\
BR 		HTML_txt	 	0 0 0 1 0		0 0 0 0\n\
BOLD 		HTML_txtBold	 	1 0 0 0 0		0 0 0 0\n\
STRONG		HTML_txtBold	 	1 0 0 0 0		0 0 0 0\n\
EM 		HTML_txtEmphasis 	1 0 0 0 0		0 0 0 0\n\
EMPH		HTML_txtEmphasis 	1 0 0 0 0		0 0 0 0\n\
I 		HTML_txtItalic	 	1 0 0 0 0		0 0 0 0\n\
ITALIC 		HTML_txtItalic	 	1 0 0 0 0		0 0 0 0\n\
TT 		HTML_txtItalic	 	1 0 0 0 0		0 0 0 0\n\
CODE 		HTML_txtCommand 	1 0 0 0 0		0 0 0 0\n\
KEY 		HTML_txtCommand 	1 0 0 0 0		0 0 0 0\n\
KBD 		HTML_txtCommand 	1 0 0 0 0		0 0 0 0\n\
CMD 		HTML_txtCommand 	1 0 0 0 0		0 0 0 0\n\
VAR 		HTML_txtCommand 	1 0 0 0 0		0 0 0 0\n\
DFN 		HTML_txtItalic	 	1 0 0 0 0		0 0 0 0\n\
CITE 		HTML_txtItalic	 	1 0 0 0 0		0 0 0 0\n\
SAMP 		HTML_txtCommand	 	1 0 0 0 0		0 0 0 0\n\
U 		HTML_txtUnderline 	1 0 0 0 0		0 0 0 0\n\
UNDER 		HTML_txtUnderline 	1 0 0 0 0		0 0 0 0\n\
HPANE	 	HTML_hpane 		0 0 0 1 1		0 0 0 0\n\
H1 		HTML_header_big 	0 0 0 1 0		10 10 0 2\n\
H2 		HTML_header_medium 	0 0 0 1 0		10 10 0 2\n\
H3 		HTML_header_small 	0 0 0 1 0		10 10 0 2\n\
H4 		HTML_header_small 	0 0 0 1 0		10 10 0 2\n\
H5 		HTML_header_small 	0 0 0 1 0		10 10 0 2\n\
H6 		HTML_header_small 	0 0 0 1 0		10 10 0 2\n\
H7 		HTML_header_small 	0 0 0 1 0		10 10 0 2\n\
XMP		HTML_example 		0 0 0 1 0		3 7 5 5\n\
SCREEN	 	HTML_plain 		0 0 0 1 0		3 7 5 5\n\
LIT	 	HTML_listing 		0 0 0 1 0		3 7 5 5\n\
LISTING 	HTML_listing 		0 0 0 1 0		0 0 0 0\n\
TITLE 		HTML_title 		0 0 0 0 0		0 0 0 0\n\
LI 		HTML_listSep	 	0 0 0 1 0		0 2 0 0\n\
P_in_listSep	HTML_listTxt	 	0 0 0 1 0		0 3 33 5\n\
OL		HTML_listNumbered	0 0 0 1 0		3 3 5 5\n\
OLC		HTML_listNumberedC	0 0 0 1 0		3 3 5 5\n\
UL 		HTML_list  		0 0 0 1 0		2 3 5 5\n\
ULC 		HTML_listC  		0 0 0 1 0		2 3 5 5\n\
DL 		HTML_fld		0 0 0 1 0		3 4 5 5\n\
DT 		HTML_txtDT		0 0 0 1 0		0 1 0 5\n\
DD 		HTML_txtDD		0 0 0 1 0		0 1 100 0\n\
ADDRESS		HTML_address 		0 0 0 1 0		10 10 100 5\n\
ISINDEX		HTML_isIndex 		0 0 0 1 0		3 7 5 5\n\
HEAD		HTML_head 		0 0 0 0 0		0 0 0 0\n\
BODY		HTML_body 		0 0 0 1 0		0 10 5 5\n\
HTML 		HTML_fld 		0 0 0 1 0		0 10 0 2\n\
MENU		HTML_menu 		0 0 0 1 0		3 7 5 25\n\
NEXTID		HTML_nextID 		0 0 0 0 0		0 0 0 0\n\
PRE		HTML_pre 		0 0 0 1 0		3 7 5 25\n\
EXAMPLE		HTML_example 		0 0 0 1 0		3 7 5 25\n\
PLAIN		HTML_plain 		0 0 0 1 0		3 7 5 25\n\
BLOCKQUOTE	HTML_fld		0 0 0 1 0		3 4 20 20\n\
IMG		HTML_img 		1 0 0 0 0		3 7 5 25\n\
IMAGE		HTML_img 		1 0 0 0 0		3 7 5 25\n\
INSERT		HTML_insert		0 0 0 1 0		3 7 1 1\n\
COMMENT		HTML_fld 		0 0 0 1 0		3 7 5 25\n\
DLC		HTML_fld 		0 0 0 1 0		3 7 5 25\n\
PLAINTEXT	HTML_plain 		0 0 0 1 0		3 7 5 25\n\
QUOTE		HTML_fld 		0 0 0 1 0		3 7 5 25\n\
FIG		HTML_figure 		0 0 0 1 0		5 3 0 0\n\
FIGURE		HTML_figure 		0 0 0 1 0		5 3 0 0\n\
FIGA		HTML_figa 		1 0 0 0 0		0 0 0 0\n\
FIGCAP 		HTML_fld 		0 0 0 1 0		0 3 5 5\n\
DIR 		HTML_col2 		0 0 0 1 0		3 7 5 25\n\
_HTML 		HTML__doc 		0 0 0 0 0		1 0 0 2\n\
SECTION 	HTML_fld 		0 0 0 0 0		0 10 5 5\n\
TABLE		HTML_table		0 0 0 1 0		0 10 5 5\n\
TCAP		HTML_tcap		0 0 0 0 0		0 0 0 0\n\
TH		HTML_th			0 0 0 0 0		0 0 0 0\n\
TD		HTML_td			0 0 0 0 0		0 0 0 0\n\
TR		HTML_tr			0 0 0 0 0		0 0 0 0\n\
TB		HTML_tb			0 0 0 0 0		2 2 0 0\n\
VOBJF 		HTML_vobjf 		0 0 0 1 0		3 10 5 5\n\
HR 		HTML_hr 		0 0 0 1 0		7 5 2 2\n\
VR 		HTML_vr 		0 0 0 1 0		0 0 0 0\n\
FORM		HTML_form		0 0 0 1 0		0 10 5 5\n\
FOOTNOTE	HTML_footnote		1 0 0 0 0		0 10 5 5\n\
INPUT		HTML_input		1 0 0 0 0		0 10 5 5\n\
TEXTAREA	HTML_textarea		1 0 0 0 0		0 10 5 5\n\
CAUTION		HTML_caution 		0 0 0 1 0		2 10 2 2\n\
MH		HTML_mh			0 0 0 0 0		0 0 0 0\n\
LINK		HTML_link		1 0 0 0 0		0 0 0 0\n\
\n\
# resizing problems\n\
SELECT		HTML_select		1 0 0 0 0		0 10 5 5\n\
OPTION		HTML_option		1 0 0 0 0		0 0 0 0\n\
\n\
#untested\n\
PRE 		HTML_listing 		0 0 0 1 0		3 7 5 25\n\
COL2 		HTML_col2 		0 0 0 1 0		1 1 1 2\n\
COL3 		HTML_col3 		0 0 0 1 0		1 1 1 2\n\
COL4 		HTML_col4 		0 0 0 1 0		1 1 1 2\n\
\n\
# not supported:\n\
FIGDATA		HTML_figdata 		1 0 0 1 0		0 1 0 0\n\
L 		HTML_txt 		0 0 0 1 0		3 7 0 5\n\
SUB		HTML_txtItalic	 	1 0 0 0 0		0 0 0 0\n\
SUP		HTML_txtItalic	 	1 0 0 0 0		0 0 0 0\n\
AUTHOR		HTML_ignore		1 0 0 0 0		0 0 0 0\n\
ENTRY		HTML_ignore		1 0 0 0 0		0 0 0 0\n\
VINSERT		HTML_ignore		1 0 0 0 0		0 0 0 0\n\
VSCRIPT		HTML_ignore		1 0 0 0 0		0 0 0 0\n\
VVIEW		HTML_ignore		1 0 0 0 0		0 0 0 0\n\
GROUP		HTML_ignore		1 0 0 0 0		0 0 0 0\n\
SECURITY	HTML_security		1 0 0 0 0		0 0 0 0\n\
";
